-*- coding: utf-8 -*-

commit 1f4d4558484b370999954f3ede7e3aa3a3a01ef3
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2023-03-30 21:34:08 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2023-03-30 21:34:08 +0900

    Fix previous commit

commit 153bdddfc2461ba0731e1d03982fee41d5e2b2aa
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2023-03-30 20:08:27 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2023-03-30 20:08:27 +0900

    Limit header length

commit 6439ebc47669b6e8b4409e4073a4348939994b7b
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-03-30 19:48:39 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-03-30 19:48:39 +0900

    * 2023-03-30 [ci skip]

commit e3f18f7d2e034f20053d7bf2fc7a50f8b7e1a27a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-12-30 14:32:05 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2023-03-30 19:48:27 +0900

    Make RFC2822 regexp linear

    https://hackerone.com/reports/1485501

commit be9026a7b4d2c3a6bd7f109334149f4da08cf43f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-11-29 16:22:15 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2023-03-30 19:48:27 +0900

    Test for quadratic backtracking on invalid time

    https://hackerone.com/reports/1485501

commit 2cb830602f52e7e76c6781115e7938b21f881c4f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-11-29 16:22:15 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2023-03-30 19:48:27 +0900

    Fix quadratic backtracking on invalid time

    https://hackerone.com/reports/1485501

commit 332135b9a9138aee05d0fdbdc6ae8bb9788b222d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-03-28 18:09:32 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2023-03-29 10:57:28 +0900

    Ubuntu 18.04 in GHA is retired

commit 33c0889ca39469eb233f8011a76254049fcc702c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-03-26 23:10:50 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2023-03-29 10:57:28 +0900

    Historical timezones of Lisbon in tzdata are unstable

commit ab2fabf34d09444b95ae1a2dcf4214a9841da66a
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2023-03-26 15:23:10 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2023-03-29 10:57:28 +0900

    Skip test_europe_lisbon on macOS

    until we figure out why it's failing.

commit cc705648a71260caa773c0d29fcaf2789c910142
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-06-04 07:58:49 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2023-03-29 10:57:28 +0900

    Removed fetch-depth

    Only the last commit is used, unless creating the ChangeLog file.

commit a57ffec6c01a994e27776e0494adeb0eca149d2d
  Author:     卜部昌平 <shyouhei@ruby-lang.org>
  AuthorDate: 2020-05-11 18:37:08 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2023-03-29 10:57:28 +0900

    .github: use actions/checkout@v2 again

commit c942a3cffefa1b35f4b0b06536c6f3a6bf312588
  Author:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  AuthorDate: 2020-03-30 17:35:49 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2023-03-29 10:57:28 +0900

    Use `--depth` on pull request

    `--shallow-since=yesterday` for COMMIT_NUMBER_OF_DAY of `tool/actions-commit-info.sh`.
    COMMIT_NUMBER_OF_DAY is mainly for master branch.
    And `--shallow-since=yesterday` may fail on pull request.
    So this revert to `--depth` on pull request.

commit f95f5fda8ae9b6a88cbd90096fa10b26bbc1932a
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2023-03-29 10:17:36 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2023-03-29 10:17:36 +0900

    * 2023-03-29 [ci skip]

commit 6fa7e5e05b5f62cd97af0f35627377c053d552af
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-03-28 18:00:13 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2023-03-29 10:17:23 +0900

    Added assert_linear_performance for URI tests

commit 14f025a738b5c5d5bea5ef159af6169c14008f13
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-03-28 17:37:48 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2023-03-29 10:17:23 +0900

    Merge URI-0.10.0.2 for bundler

commit 6855779d580358a6a0b4c9ee06f20e7cae72955a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-03-28 17:33:19 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2023-03-29 10:17:23 +0900

    Merge URI-0.10.0.2

commit 36cadad6434bc31bc2d60697698cd5b930c097ce
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-12-08 12:33:58 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-12-08 12:33:58 +0900

    merge revision(s) 58cc3c9f: [Backport #19187]

            [Bug #19187] Fix for tzdata-2022g

            ---
             test/ruby/test_time_tz.rb | 21 +++++++++++++++------
             1 file changed, 15 insertions(+), 6 deletions(-)

commit d21f98531f118df39c4876424d53e4f8c3acc3e0
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-12-08 12:33:42 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-12-08 12:33:42 +0900

    Bump teeny

commit 168ec2b1e5ad0e4688e963d9de019557c78feed9
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-11-24 21:42:08 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-11-24 21:42:08 +0900

    Use %printer directive for Bison 3.8 (used release flow)

    This is backport of fa05697e4832fbd67a4f91b9bb362471902faab3

commit ee8dc8a2f3ee7983d18339ea31444a981e63a874
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-11-24 20:43:04 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-11-24 20:43:04 +0900

    Fix GitHub Actions error

commit 9308e32aa64b3d7da909356c6a225dcc55857bcf
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2022-09-08 23:02:44 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-11-24 20:06:00 +0900

    Merge openssl-2.1.4

    The changes can be found at:

      https://github.com/ruby/openssl/compare/v2.1.3...v2.1.4

commit 9eee81bcd0c83594c4c3314b2fec3fc94953322f
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-11-24 19:42:05 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-11-24 19:42:05 +0900

    Bump version

commit ca07082a76640af6594af2d1941c8a82f55ade4d
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-11-24 11:21:03 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-11-24 11:21:03 +0900

    * 2022-11-24 [ci skip]

commit fa7fab95b9a2a3d2481ba803c1db31393c940bf7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-04-28 23:36:16 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-11-24 11:20:51 +0900

    Removed unnecessary RLIMIT_AS

    Even without this limit, these assertions almost certainly cause a
    NoMemoryError by removing the fix in 72ad8595f20.

commit 233634fbdcb1f2f8979603feb8ba9865ab30c823
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-20 20:30:28 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-11-24 11:20:51 +0900

    merge revision(s) 4f1e0bfacd93c28bff549e2f3603c3b4942429a3:

            Followed up CVE-2022-39253 for bundler examples

            ---
             spec/bundler/cache/git_spec.rb           | 3 +++
             spec/bundler/install/gemfile/git_spec.rb | 9 +++++++++
             spec/bundler/update/git_spec.rb          | 3 +++
             3 files changed, 15 insertions(+)

commit 7f1163e9a564f88075ce53389165d9aef9593e66
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-11-23 10:43:44 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-11-24 11:20:51 +0900

    Use ubuntu-20.04 instead of latest, because Ruby 2.7 didn't support openssl3 on Ubuntu 22.04

commit 39f6a33e2399d8dfe88ae0a1c5b38843ffea9e71
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-11-22 20:55:17 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-11-24 11:20:51 +0900

    merge revision(s) 36f297e62108072b9377d927321928b994f66a93:

            Use valid tokens as cookie names

            ---
             spec/ruby/library/cgi/cookie/name_spec.rb  | 12 ++++++------
             spec/ruby/library/cgi/cookie/parse_spec.rb | 10 +++++-----
             2 files changed, 11 insertions(+), 11 deletions(-)

commit 25df68ae91ce0f6e8b78aa42e840e785e5e191ed
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2022-10-20 20:30:06 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-11-24 11:20:51 +0900

    merge revision(s) dae843f6b7502f921a7e66f39e3714a39d860181,86096a91d55f72620e0f8ca8634da5fa342dc35b:

            Bypass git submodule add/update with git config
             protocol.file.allow=always option.

            Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
            ---
             test/rubygems/test_gem_source_git.rb | 5 +++++
             1 file changed, 5 insertions(+)

            [rubygems/rubygems] Use [] instead of double-quotes

            ---
             test/rubygems/test_gem_source_git.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit f33522baac8320883c0acac226d8fab29c9df400
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2022-10-14 08:28:16 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-11-24 11:20:51 +0900

    Upgrade zlib_version on AppVeyor

    They removed https://zlib.net/zlib1212.zip because
    https://zlib.net/zlib1213.zip was released :thinking_face:

    Fix CI failures like:
    https://ci.appveyor.com/project/ruby/ruby/builds/45064876/job/bb9biogolh0u2595

commit 7cf697179dab52b0d024543304f4d3ab5fa5e847
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-11-22 13:48:18 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-11-24 11:20:51 +0900

    Merge CGI-0.1.0.2

commit 7b413c1db3e65909c6899e1d3be4d16c3e76149c
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-10-01 15:59:05 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-10-01 15:59:05 +0900

    * 2022-10-01 [ci skip]

commit 022aefb4500bfb8f6812a5e729d06f3f2fe21cea
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2022-09-24 03:36:04 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-10-01 15:58:54 +0900

    Initialize Objective-C classes before fork() for macOS 13

    Since macOS 13, CFString family API used in
    `rb_str_append_normalized_ospath` may internally use Objective-C classes
    (`NSTaggedPointerString` and `NSPlaceholderMutableString`) for small strings.

    On the other hand, Objective-C classes should not be used for the first
    time in a `fork()`'ed but not `exec()`'ed process. Violations for this rule
    can result deadlock during class initialization, so Objective-C runtime
    conservatively crashes on such cases by default.

    Therefore, we need to use CFString API to initialize Objective-C classes
    used internally *before* `fork()`.

    For more details, see https://bugs.ruby-lang.org/issues/18912

commit 99735a8b296cfda272f8dce6bd07af50cd97034e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-09-17 12:09:34 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-10-01 15:58:54 +0900

    [Bug #19005] dynamic_lookup linker option in external libraries

    The warning against `-undefined dynamic_lookup` is just a warning yet,
    and many gems seem to pay no attention to warnings.  Until it fails
    actually, keep it as a migration path, except for standard extension
    libraries and bundled extension gems.

commit 9188c5dd6d8d8c411ea698fff747643845e92f64
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-09-13 23:56:34 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-10-01 15:58:54 +0900

    -undefined dynamic_lookup is obsolete

commit 6b099328af2ae2d04cbfd06fedc36a19cdecd30d
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-09-20 18:46:48 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-09-20 18:46:48 +0900

    * 2022-09-20 [ci skip]

commit 6ff627e57ee19eeab29ae411f442fa3f6a801a5a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-09-20 17:11:51 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-09-20 18:46:34 +0900

    update ubuntu 18.04 for github actions

commit 13354c02a6a070bd63443397f7dfed5d7c15d2cb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-09-16 19:40:21 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-09-20 18:46:34 +0900

    zlib-1.2.11 is removed at zlib.net

commit 302e366800e491009013288e10a96c4866f9900b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2022-08-17 00:45:27 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-09-20 18:46:34 +0900

    The tzdata 2022c removed Amsterdam Mean Time

commit 4c7ae840818f995ef776ef99c3ee275d14bd3869
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-09-16 18:33:25 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-09-20 18:46:34 +0900

    Use autoreconf -i instead of autoconf

commit a62cfce75f2617d8e85883be1fdfafea50c1b72c
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-09-16 15:11:21 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-09-16 15:11:21 +0900

    * 2022-09-16 [ci skip]

commit 31bc55dc90aa18222d5ed968e62fea4d46554d8c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2022-08-29 17:42:49 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2022-09-16 15:11:08 +0900

    Backport https://github.com/ruby/ruby/pull/6193

    Co-authored-by: Yuta Saito <kateinoigakukun@gmail.com>

commit c9c2245c0a25176072e02db9254f0e0c84c805cd
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-04-12 20:25:48 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-04-12 20:25:48 +0900

    Fix dtoa buffer overrun

commit 389723d85433df0b487f02c94ca6a243d39a189e
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2022-04-07 22:52:52 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2022-04-07 22:52:52 +0900

    * 2022-04-07 [ci skip]

commit 334ca2dc06931ec7da93787635a00ec0f1aad086
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-03-19 22:50:51 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-03-19 22:50:51 +0900

    merge revision(s) 496591de96b261b8789332c7f8b2bfbd17658955: [Backport #18578]

        st.c: Do not clear entries_bound when calling Hash#shift for empty
         hash

        tab->entries_bound is used to check if the bins are full in
        rebuild_table_if_necessary.

        Hash#shift against an empty hash assigned 0 to tab->entries_bound, but
        didn't clear the bins. Thus, the table is not rebuilt even when the bins
        are full. Attempting to add a new element into full-bin hash gets stuck.

        This change stops clearing tab->entries_bound in Hash#shift.
        [Bug #18578]
        ---
         st.c                   |  1 -
         test/ruby/test_hash.rb | 13 +++++++++++++
         2 files changed, 13 insertions(+), 1 deletion(-)

commit 19fec939a6fed650135c6ce8b567fcb7b001b068
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-03-19 22:45:51 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-03-19 22:45:51 +0900

    merge revision(s) c79d2e54748f52c5023b0a1ee441561df9826c17: [Backport #18562]

        Fix TAG_THROW through require [Bug #18562]

        Previously this was being incorrectly swapped with TAG_RAISE in the next
        line. This would end up checking the T_IMEMO throw_data to the exception
        handling (which calls Module#===). This happened to not break existing
        tests because Module#=== returned false when klass is NULL.

        This commit handles throw from require correctly by jumping to the tag
        retaining the TAG_THROW state.
        ---
         load.c                      |  2 +-
         test/ruby/test_exception.rb | 21 +++++++++++++++++++++
         2 files changed, 22 insertions(+), 1 deletion(-)

commit 7eaec9a6b355a685a3a9503a005b91f4b3cb4f39
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-03-19 22:41:16 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-03-19 22:41:16 +0900

    merge revision(s) b555e659c4974acc423083b71b1bd5ec6a926046: [Backport #18388]

        Do not use `fcopyfile` if appending to non-empty file [Bug #18388]

        `fcopyfile` appends `src` to `to` and then truncates `to` to it's
        original size.
        ---
         io.c                 |  7 +++++++
         test/ruby/test_io.rb | 12 ++++++++++++
         2 files changed, 19 insertions(+)

commit 5da2a3e31699570ae1a951c8bbc489040051d19e
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-03-19 22:34:37 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-03-19 22:34:37 +0900

    merge revision(s) 7ff1bf317887c0d7b21e91ad548d07b9f05c540c,e89d80702bd98a8276243a7fcaa2a158b3bfb659: [Backport #18516]

        An alias can suppress method redefinition warning

        ---
         test/ruby/test_alias.rb | 11 +++++++++++
         1 file changed, 11 insertions(+)

        Fix memory leak at the same named alias [Bug #18516]

        When aliasing a method to the same name method, set a separate bit
        flag on that method definition, instead of the reference count
        increment.  Although this kind of alias has no actual effect at
        runtime, is used as the hack to suppress the method re-definition
        warning.
        ---
         method.h                |  1 +
         test/ruby/test_alias.rb | 18 ++++++++++++++++++
         vm_method.c             |  9 ++++++++-
         3 files changed, 27 insertions(+), 1 deletion(-)

commit 2d886af0a55a99bf3c12ec82c1b7a804bec9d395
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-03-19 22:27:18 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-03-19 22:27:18 +0900

    merge revision(s) 6a6227e0168b059c3ed34c9f0ace2e5dc2364221: [Backport #18517]

            Shifting zero always results in zero [Bug #18517]

            ---
             numeric.c | 2 ++
             1 file changed, 2 insertions(+)

commit 81f5453bd831e6f09e660fdf7e72d3d2da8753e7
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-03-19 22:23:08 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-03-19 22:23:08 +0900

    merge revision(s) 5c7af72304d0ad33cd3f21b24a4bc44e8acd5b2c,d650b17686d49c2ce8e6a87039861154e93d4621: [Backport #18497]

        Assuming EXIT_SUCCESS equals 0 is not portable

        ---
         test/ruby/test_fiber.rb | 6 +++---
         1 file changed, 3 insertions(+), 3 deletions(-)

        `rb_fiber_terminate` must not return [Bug #18497]

        In a forked process from a fiber, the fiber becomes the only
        fiber, `fiber_switch` does nothing as there is no other fibers,
        `rb_fiber_terminate` does not terminate the fiber.  In that case,
        reaches the end of `fiber_entry` finaly, which is declared as
        "COROUTINE" and should never return.
        ---
         cont.c                     |  3 ++-
         eval_intern.h              |  2 +-
         test/fiber/test_process.rb | 15 +++++++++++++++
         test/ruby/test_fiber.rb    |  5 +++++
         4 files changed, 23 insertions(+), 2 deletions(-)

        note that only backported a part of above patch because of incompatibility
        of ruby_2_7.

commit ea9b0fe5d30efaa7dad1be4da79c1ee58f4f963b
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-03-19 22:15:40 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-03-19 22:15:40 +0900

    merge revision(s) ae5458f228a5477383e9c00425d85d50a3867817: [Backport #18475]

        thread.c: Convert TAG_BREAK to a normal exception at thread top-level

        [Bug #18475]
        ---
         test/ruby/test_enum.rb | 11 +++++++++++
         thread.c               |  3 +++
         2 files changed, 14 insertions(+)

commit 83de7133876ec392eb4b3b69c2220d7b49685444
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-03-05 22:01:07 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-03-05 22:01:07 +0900

    merge revision(s) c51b92c18deb850d2cea3a7c9020db23b364ab72: [Backport #18358]

        [ruby/zlib] [Bug #18358] Fix crash in zlib when in progress

        When Zlib::Inflate#inflate or Zlib::Deflate#deflate is called
        recursively inside the block, a crash can occur because of an
        use-after-free bug.

        https://github.com/ruby/zlib/commit/50fb8a0338
        ---
         ext/zlib/zlib.c        | 117 ++++++++++++++++++++++++++++++++-----------------
         test/zlib/test_zlib.rb |  10 ++++-
         2 files changed, 85 insertions(+), 42 deletions(-)

commit f740ffb81f3ef11526add528583b0cbfce28af67
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2022-03-05 21:38:48 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2022-03-05 21:38:48 +0900

    merge revision(s) b3d62a77d928eff01268ca7fa1c1c0966702926d [Backport #17803]

        [ruby/zlib] Synchronize access to zstream to prevent segfault in
         multithreaded use

        I'm not sure whether this handles all multithreaded use cases,
        but this handles the example that crashes almost immediately
        and does 10,000,000 total deflates using 100 separate threads.

        To prevent the tests from taking forever, the committed test
        for this uses only 10,000 deflates across 10 separate threads,
        which still causes a segfault in the previous implementation
        almost immediately.

        Fixes [Bug #17803]

        https://github.com/ruby/zlib/commit/4b1023b3f2
        ---
         ext/zlib/zlib.c        | 33 ++++++++++++++++++++++++++-
         test/zlib/test_zlib.rb | 61 ++++++++++++++++++++++++++++++++++++++++++++++++++
         2 files changed, 93 insertions(+), 1 deletion(-)

commit 1034b6e7ba9442320e16c260d634d4c64d5e62bf
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-12-31 19:48:36 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-12-31 19:48:36 +0900

    merge revision(s) 0c5f8c62766afe4605172800063e63fe36996658: [Backport #10961]

            [ruby/zlib] Resume zstream if available [Bug #10961]

            ---
             ext/zlib/zlib.c | 6 ++++++
             1 file changed, 6 insertions(+)

commit 1cc5567b46249e6b4bd2dd3cfdd348ab885f59e3
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-12-31 19:48:29 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-12-31 19:48:29 +0900

    merge revision(s) 0846c2da457e7523819236ac7da492029b3ef73d,6c7cb00c094332a208cf36e5cd723a9ba60c41b8: [Backport #16376]

            Check backref number buffer overrun [Bug #16376]

            ---
             regcomp.c                | 21 ++++++++++++---------
             test/ruby/test_regexp.rb |  6 ++++++
             2 files changed, 18 insertions(+), 9 deletions(-)

            test/ruby/test_regexp.rb: Avoid "ambiguity between regexp and two
             divisions"

            ---
             test/ruby/test_regexp.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 426266af2cbfba8d42a82abcce1bb3ca6c039e87
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-12-31 19:48:24 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-12-31 19:48:24 +0900

    merge revision(s) fdf39963490cf2cf95b30d91bb9b35964c2c2350: [Backport #18421]

            Empty and return the buffer if zero size is given [Bug #18421]

            In `IO#readpartial` and `IO#read_nonblock`, as well as `IO#read`.
            ---
             io.c                 |  8 ++++++--
             test/ruby/test_io.rb | 21 +++++++++++++++++++++
             2 files changed, 27 insertions(+), 2 deletions(-)

commit 7d3cff6e41d73a00f3d0fdb337743f654e42f1a8
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-12-31 19:48:17 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-12-31 19:48:17 +0900

    merge revision(s) a2d4e1cda68a49980a4f9f353f400efbde7e7884,d6c5a30cfdf658280338dbb8c8b17fab3190b928: [Backport #18392]

            Fixed the check order in wmap_live_p [Bug #18392]

            Check if the object is a pointer to heap before check the flag in
            that object.
            ---
             gc.c | 35 ++++++++++++++++++++++-------------
             1 file changed, 22 insertions(+), 13 deletions(-)

            ObjectSpace::WeakMap#inspect: check if living object [Bug #18392]

            ---
             gc.c                      | 29 +++++++++++++++++++++++------
             test/ruby/test_weakmap.rb |  9 +++++++++
             2 files changed, 32 insertions(+), 6 deletions(-)

commit b829811131ec7741ce701ff8a8b101604fb0d595
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-12-31 19:48:13 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-12-31 19:48:13 +0900

    merge revision(s) 43a3c88187dcd54ba008834a865e50eb28a78de9: [Backport #18372]

            [win32] get rid of redefinition of reserved macro

            ```
            warning C4117: macro name '_INTEGRAL_MAX_BITS' is reserved, '#define' ignored
            ```
            ---
             win32/Makefile.sub | 2 ++
             1 file changed, 2 insertions(+)

commit c24f436c2a4b343f9cb4950260376546f5ff0d06
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-12-31 19:47:57 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-12-31 19:47:57 +0900

    merge revision(s) 9f8a50723f8a84b3e4755b418570148f422d1b28: [Backport #17836]

            Specify -c to emit pch with clang (#4423)

            [Bug #17836]
            ---
             mjit_worker.c | 1 +
             1 file changed, 1 insertion(+)

commit f69aeb83146be640995753667fdd6c6f157527f5
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-11-24 20:21:17 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-11-24 20:21:17 +0900

    merge some parts of CGI 0.1.1

            Fix integer overflow

            Make use of the check in rb_alloc_tmp_buffer2.

            When parsing cookies, only decode the values

            Bump version

commit b1985629565c3c54b1a64d6faf213e8144857515
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-11-24 19:38:18 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-11-24 19:38:18 +0900

    merge revision(s) e83c02a768af61cd0890a75e90bcae1119d8bd93: [Backport #18289]

            Delegate keywords from Enumerable#to_a to #each

            Fixes [Bug #18289]
            ---
             enum.c                 | 2 +-
             test/ruby/test_enum.rb | 5 +++++
             2 files changed, 6 insertions(+), 1 deletion(-)

commit 1d4e037a8011ac05b4ede8cdf8263515ba0e095e
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-11-24 19:37:50 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-11-24 19:37:50 +0900

    merge revision(s) a4d5ee4f31bf3ff36c1a8c8fe3cda16aa1016b12: [Backport #18264]

            [Bug #18264] Fix memory leak in TracePoint

            TracePoint leaks memory because it allocates a `rb_tp_t` struct
            without ever freeing it (it is created with `RUBY_TYPED_NEVER_FREE`).
            ---
             test/ruby/test_settracefunc.rb | 10 ++++++++++
             vm_trace.c                     |  2 +-
             2 files changed, 11 insertions(+), 1 deletion(-)

commit 419266d44c54c6b75f1e824f060c8b388f7a405b
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-11-24 19:36:07 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-11-24 19:36:07 +0900

    merge revision(s) 89242279e61b023a81c58065c62a82de8829d0b3,529fc204af84f825f98f83c34b004acbaa802615: [Backport #18141]

            Marshal.load: do not call the proc until strings have their encoding

            Ref: https://bugs.ruby-lang.org/issues/18141
            ---
             marshal.c                             |  7 +++-
             spec/ruby/core/marshal/shared/load.rb | 62 +++++++++++++++++++++++------------
             test/ruby/test_marshal.rb             | 17 ++++++++++
             3 files changed, 64 insertions(+), 22 deletions(-)

            marshal.c: don't call the proc with partially initialized objects.
             (#4866)

            For cyclic objects, it requires to keep a st_table of the partially
            initialized objects.
            ---
             marshal.c                             | 75 ++++++++++++++++++++---------------
             spec/ruby/core/marshal/shared/load.rb | 75 ++++++++++++++++++++---------------
             test/ruby/test_marshal.rb             | 12 ++++++
             3 files changed, 97 insertions(+), 65 deletions(-)

commit 61a02168f7ba353a2838f2783f291a816d7e0c90
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-11-24 19:34:59 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-11-24 19:34:59 +0900

    merge revision(s) ddb32e66160ab50849419ef7c7ac584913b79c34: [Backport #18173]

            [Bug #18173] Update loaded_features_index

            If $LOADED_FEATURES is changed in the just required file, also the
            index table needs to be updated before loaded_features_snapshot is
            reset.  If the snapshot is reset without updating the table, the
            name of the added feature will not be found.
            ---
             load.c                    |  1 +
             test/ruby/test_require.rb | 17 +++++++++++++++++
             2 files changed, 18 insertions(+)

commit cd10572b059d07fe236ef9c9db9fd2a8ffc7dd38
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-11-24 19:34:03 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-11-24 19:34:03 +0900

    merge revision(s) 99d8c4832a7133ca52578d015e3ddcfd94820f4a: [Backport #18160]

            Preserve the encoding of the argument in IndexError [Bug #18160]

            ---
             re.c                     | 20 ++++++++++----------
             test/ruby/test_regexp.rb |  7 ++++++-
             2 files changed, 16 insertions(+), 11 deletions(-)

commit d55426f800546cbc3b333ae7ab98c1893f710612
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-11-24 19:31:43 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-11-24 19:31:43 +0900

    merge revision(s) 5d815542815fe8b939239750bba7f8f0b79c97d6: [Backport #18154]

            [Bug #18154] Fix memory leak in String#initialize

            String#initialize can leak memory when called on a string that is marked
            with STR_NOFREE because it does not unset the STR_NOFREE flag.
            ---
             string.c                 |  2 +-
             test/ruby/test_string.rb | 10 ++++++++++
             2 files changed, 11 insertions(+), 1 deletion(-)

commit 0fd9588395294ac97a1f6dc3a51d4f19e84a6ba9
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-11-24 19:31:06 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-11-24 19:31:06 +0900

    merge revision(s) d795f494a89e0d9498dfedc54b8a98acc2bc4d7b: [Backport #17794]

            Avoid `free(3)`ing invalid pointer

            Fixes [Bug #17794]
            ---
             addr2line.c | 2 ++
             1 file changed, 2 insertions(+)

commit f236548038048118e766232034511e4877a59b49
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-11-24 19:27:06 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-11-24 19:27:06 +0900

    merge revision(s) 345db8f2aa373a31c619c8f85bd372f0a20829c1: [Backport #10902]

            Avoid pointless attempts to open .so file if already required

            When attempting to require a file without an extension that has
            already been required or provided with an .so extension, only
            look for files with an .rb extension. There is no point in
            trying to find files with an .so extension, since we already
            know one has been loaded.

            Previously, attempting to require such a file scanned the load
            path twice, once for .rb and once for .so.  Now it only scans
            once for .rb.  The scan once for .rb cannot be avoided, since
            the .rb file would take precedence and should be loaded if it
            exists.

            Fixes [Bug #10902]
            ---
             load.c | 7 ++++++-
             1 file changed, 6 insertions(+), 1 deletion(-)

commit 7d4d38f8838579592e70fb04a6a2f0162fe989c2
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-11-24 19:26:29 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-11-24 19:26:29 +0900

    merge revision(s) b360588cd3cbac5fb4f004aa53a8fdc715906719: [Backport #15856]

            Sort feature index arrays by the priority of file types [Bug #15856]

            When looking for libraries to load with a feature name without
            extension, `.rb` files are given priority. However, since the
            feature index arrays were not in that order of priority, but in
            the order in which they were loaded, a lower priority extension
            library might be returned. In that case, the `.rb` file had to be
            searched for again from the `$LOAD_PATH`, resulting in poor
            performance.
            ---
             load.c | 52 +++++++++++++++++++++++++++++++++++++++++++++-------
             1 file changed, 45 insertions(+), 7 deletions(-)

commit 6601fb5672dc4c1f4bf5ee0f9b3f97a029df06cd
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-11-24 19:25:38 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-11-24 19:25:38 +0900

    merge revision(s) 25e56fe374478a2266ac25f22a07bb3c6a423c83,8758b07b1e4fd636dffb4b442388a3033c63d4b5,791e8eec66d3aebcee36c1369b0bf52bc3815e94: [Backport #18016]

            [ruby/fiddle] Fix Win32Types for Windows 64-bit (#63)

            https://docs.microsoft.com/en-us/windows/win32/winprog/windows-data-types

            https://github.com/ruby/fiddle/commit/28ee5b1608
            ---
             ext/fiddle/lib/fiddle/types.rb | 8 ++++----
             1 file changed, 4 insertions(+), 4 deletions(-)

            [ruby/fiddle] Fix more Win32Types definitions

            https://docs.microsoft.com/en-us/windows/win32/winprog/windows-data-types

            https://github.com/ruby/fiddle/commit/805c1a595a
            ---
             ext/fiddle/lib/fiddle/types.rb | 23 ++++++++++++-----------
             1 file changed, 12 insertions(+), 11 deletions(-)

            [ruby/fiddle] win32types: sort

            https://github.com/ruby/fiddle/commit/35dec6c5a5
            ---
             ext/fiddle/lib/fiddle/types.rb | 30 +++++++++++++++---------------
             1 file changed, 15 insertions(+), 15 deletions(-)

commit ade896702e58b8b2505998345c15c3987bdf278b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-11-24 16:28:45 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2021-11-24 17:55:25 +0900

    Merge date-3.0.3

commit 06aafeb4b3a855966262da4855a5ba43d672d5e4
  Author:     Dimitry Andric <dimitry@andric.com>
  AuthorDate: 2021-05-16 03:58:26 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2021-11-24 17:49:38 +0900

    Fix clang -Wcompound-token-split-by-macro warning in ruby.h

    Building certain ruby gem native extensions (such as thrift), with clang
    12.0.0 or later fails, because they have -Werror in their CFLAGS,
    resulting in complaints about the expansion of the `rb_intern()` macro:

    ```
    current directory: /wrkdirs/usr/ports/devel/rubygem-thrift/work/stage/usr/local/lib/ruby/gems/2.7/gems/thrift-0.14.0/ext
    make "DESTDIR="
    compiling binary_protocol_accelerated.c
    binary_protocol_accelerated.c:404:68: error: '(' and '{' tokens introducing statement expression appear in different macro expansion contexts [-Werror,-Wcompound-token-split-by-macro]
      VALUE thrift_binary_protocol_class = rb_const_get(thrift_module, rb_intern("BinaryProtocol"));
                                                                       ^~~~~~~~~~~~~~~~~~~~~~~~~~~
    @@HOMEBREW_PREFIX@@/include/ruby-2.7/ruby/ruby.h:1847:23: note: expanded from macro 'rb_intern'
            __extension__ (RUBY_CONST_ID_CACHE((ID), (str))) : \
                          ^
    binary_protocol_accelerated.c:404:68: note: '{' token is here
      VALUE thrift_binary_protocol_class = rb_const_get(thrift_module, rb_intern("BinaryProtocol"));
                                                                       ^~~~~~~~~~~~~~~~~~~~~~~~~~~
    @@HOMEBREW_PREFIX@@/include/ruby-2.7/ruby/ruby.h:1847:24: note: expanded from macro 'rb_intern'
            __extension__ (RUBY_CONST_ID_CACHE((ID), (str))) : \
                           ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    @@HOMEBREW_PREFIX@@/include/ruby-2.7/ruby/ruby.h:1832:5: note: expanded from macro 'RUBY_CONST_ID_CACHE'
        {                                                   \
        ^
    ```

    Part of the `rb_intern()` macro expands to `(RUBY_CONST_ID_CACHE((ID),
    (str)))`, and in turn `RUBY_CONST_ID_CACHE()` expands to a brace
    enclosed compound statement. The intended effect is to get a gcc
    statement expression, which is normally delimited by `({ ... })`.

    However, clang 12.0.0 and later have a warning enabled by default, about
    pasting together the `(` and `{` tokens via different macros (see
    <https://github.com/llvm/llvm-project/commit/0e00a95b4fad5e72851de012d3a0b2c2d01f8685>).

    To work around this warning:
    * Add `RUBY_CONST_ID_CACHE_NB()` (i.e. no-brace) which contains the code
      itself, without any braces
    * `RUBY_CONST_ID_CACHE()` which uses `RUBY_CONST_ID_CACHE_NB()`, but
       puts braces around it (so no existing code using this macro breaks)
    * Finally, change `rb_intern()` so the `__extension__` directly creates
      a gcc statement expression, using the `RUBY_CONST_ID_CACHE_NB()` macro

commit f180f4607cd129a4fe8d1ed671bb7d39d71dda97
  Author:     Andrew Aladjev <aladjev.andrew@gmail.com>
  AuthorDate: 2021-02-24 05:18:08 +0900
  Commit:     U.Nakamura <usa@ruby-lang.org>
  CommitDate: 2021-11-24 17:42:52 +0900

    Backport mutexes for socket and connection lists on win32 #4212

commit 5bd0c0a014d3cb1e07b355208dbfd2352f8dc08c
  Author:     Alan D. Salewski <salewski@att.net>
  AuthorDate: 2020-07-05 04:40:10 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2021-11-24 16:56:29 +0900

    merge revision(s) c15cddd1d515c5bd8dfe8fb2725e3f723aec63b8: [Backport #16787]

            Allow Dir.home to work for non-login procs when $HOME not set

            Allow the 'Dir.home' method to reliably locate the user's home directory when
            all three of the following are true at the same time:

                1. Ruby is running on a Unix-like OS
                2. The $HOME environment variable is not set
                3. The process is not a descendant of login(1) (or a work-alike)

            The prior behavior was that the lookup could only work for login-descended
            processes.

            This is accomplished by looking up the user's record in the password database
            by uid (getpwuid_r(3)) as a fallback to the lookup by name (getpwname_r(3))
            which is still attempted first (based on the name, if any, returned by
            getlogin_r(3)).

            If getlogin_r(3), getpwnam_r(3), and/or getpwuid_r(3) is not available at
            compile time, will fallback on using their respective non-*_r() variants:
            getlogin(3), getpwnam(3), and/or getpwuid(3).

            The rationale for attempting to do the lookup by name prior to doing it by uid
            is to accommodate the possibility of multiple login names (each with its own
            record in the password database, so each with a potentially different home
            directory) being mapped to the same uid (as is explicitly allowed for by
            POSIX; see getlogin(3posix)).

            Preserves the existing behavior for login-descended processes, and adds the
            new capability of having Dir.home being able to find the user's home directory
            for non-login-descended processes.

            Fixes [Bug #16787]

            Related discussion:
                https://bugs.ruby-lang.org/issues/16787
                https://github.com/ruby/ruby/pull/3034

commit eeabac4c55e0968e3664728bcce3c0eb23cd9321
  Author:     PikachuEXE <pikachuexe@gmail.com>
  AuthorDate: 2021-08-05 16:51:15 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2021-11-24 16:47:15 +0900

    Do not allow Module#include to insert modules before the origin in the lookup chain

    Module#include should only be able to insert modules after the origin,
    otherwise it ends up working like Module#prepend.

    This fixes the case where one of the modules in the included module
    chain is included in a module that is already prepended to the receiver.

    Fixes [Bug #7844]

    Backport of https://github.com/ruby/ruby/pull/3796 to 2.7

commit e0b323632f5ea07e2646a2ec0b72f56093348265
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2021-09-28 15:55:12 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2021-11-24 16:45:46 +0900

    openssl: import v2.1.3

    Bring the local copy of ruby/openssl in sync with the upstream gem
    release v2.1.3. The commits happened in the upstream repository can be
    found at:

            https://github.com/ruby/openssl/compare/v2.1.2...v2.1.3

    Note that many of these have already been applied to ruby.git and don't
    appear in the file changes of this commit.

commit 87378782483dd8fdd03ae9d6022979f1f8153416
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2021-10-16 17:05:22 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2021-11-24 16:45:46 +0900

    tool/sync_default_gems.rb: fix path for openssl

commit 7c6b56801e46610d041835811c25cb5368cddc08
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2021-11-24 16:10:47 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2021-11-24 16:10:47 +0900

    * 2021-11-24 [ci skip]

commit b79be4b09c2ac2a8ec7e709f91c13e27791ce31d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2021-04-08 18:40:10 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2021-11-24 16:10:33 +0900

    Removed the accidental files at https://github.com/ruby/ruby/commit/931815bfd86df603337194f3fcefb46bfe3e7940

commit ac7c2754c004cdb3618738e315d2e2cb5f68a3a8
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-09-19 19:43:12 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-09-19 19:43:12 +0900

    merge revision(s) b8386f7f7f6d7a7d76481e02d389d0f5211f0f2c [Backport #18161]

        Prepend DebugSystem to VCS class only

        And revert 24e5f1c982966c379220b1bbb26b4e0320180fa1, pepending to
        Kernel did not affect the top level methods before 3.0.

commit 2a7235421fcd59b449c84306d059f22b4c5f0865
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2021-04-30 03:58:12 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2021-07-31 21:27:21 +0900

    Fix SortedSet not being sorted the first time when rbtree is used

    Fixes [Bug #17841]

commit 4b371d6ab28f9c0f041af01f76a9bcedaeeee917
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2021-07-31 21:25:04 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2021-07-31 21:25:04 +0900

    * 2021-07-31 [ci skip]

commit d9ff8b3e86a03499a5c6bc36fae1592914a25b9c
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2021-07-02 04:08:20 +0900
  Commit:     usa <usa@garbagecollect.jp>
  CommitDate: 2021-07-31 21:24:44 +0900

    Ignore timeout option to Addrinfo.getaddrinfo

    This was already ignored on platforms that do not implement
    getaddrinfo_a. Using getaddrinfo_a causes issues with many
    calls to Addrinfo.getaddrinfo and also when using
    Addrinfo.getaddrinfo with fork.

    I would have updated the documentation for this, but the
    option was already not documented.

commit a21a3b7d23704a01d34bd79d09dc37897e00922a
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2021-07-07 12:06:44 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-07-07 19:48:22 +0900

    Fix StartTLS stripping vulnerability

    Reported by Alexandr Savca in https://hackerone.com/reports/1178562

    Co-authored-by: Shugo Maeda <shugo@ruby-lang.org>

commit 3ca1399150ed4eacfd2fe1ee251b966f8d1ee469
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2021-07-07 12:05:44 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-07-07 19:47:46 +0900

    Ignore IP addresses in PASV responses by default, and add new option use_pasv_ip

    This fixes CVE-2021-81810.
    Reported by Alexandr Savca.

    Co-authored-by: Shugo Maeda <shugo@ruby-lang.org>

commit 87d02eacd26d0b2884016315baf2440d100f177e
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-06-02 01:40:08 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-06-02 01:40:08 +0900

    merge revision(s) 9edc162583a4f685332239f6249745ad9b518cbe: [Backport #17781]

            [ruby/resolv] Fix confusion of received response message

            This is a follow up for commit 33fb966197f1 ("Remove sender/message_id
            pair after response received in resolv", 2020-09-11).

            As the @senders instance variable is also used for tracking transaction
            ID allocation, simply removing an entry without releasing the ID would
            eventually deplete the ID space and cause
            Resolv::DNS.allocate_request_id to hang.

            It seems the intention of the code was to check that the received DNS
            message is actually the response for the question made within the method
            earlier. Let's have it actually do so.

            [Bug #12838] https://bugs.ruby-lang.org/issues/12838
            [Bug #17748] https://bugs.ruby-lang.org/issues/17748

            https://github.com/ruby/resolv/commit/53ca9c9209
            ---
             lib/resolv.rb | 6 +++---
             1 file changed, 3 insertions(+), 3 deletions(-)

commit 9e0e99023ddef9c0ea80dfc7f0b6924c1be95d03
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-05-31 23:47:41 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-05-31 23:47:41 +0900

    bump the verion of RDoc for previous merge

commit 483f303d02e768b69e476e0b9be4ab2f26389522
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-05-31 23:44:23 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-05-31 23:44:23 +0900

    merge revision(s) a7f5d6ab88 c9ab8fe2 [Backport#17877]

            a fix of RDoc for CVE-2021-31799

commit d8bbbc308e99635091fe9c6e89ee8d711cc008b9
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-05-31 23:10:35 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-05-31 23:10:35 +0900

    bump patchlevel for previous merge commit

commit 29bbad939939c6dceb804aac667ba372fdee4ef5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2021-05-31 23:04:44 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2021-05-31 23:04:44 +0900

    Fix 2.7 build (#4359)

    * merge revision(s) fcc88da5eb162043adcba552646677d2ab5adf55:

            configure.ac: fix for upcoming autoconf-2.70

            The failure initially noticed on `autoconf-2.69d` (soon to become 2.70):

            ```
            $ ./configure
            ./configure: line 8720: syntax error near unexpected token `fi'
            ./configure: line 8720: `fi'
            ```

            Before the change generated `./configure ` snippet looked like:

            ```
                if ! $CC -E -xc - <<SRC >/dev/null
            then :

                    #if defined __APPLE_CC__ && defined __clang_major__ && __clang_major__ < 3
                    #error premature clang
                    #endif
            SRC
                    as_fn_error $? "clang version 3.0 or later is required" "$LINENO" 5
            fi
            ```

            Note the newline that breaks here-document syntax.

            After the change the snippet does not use here-document.

            Signed-off-by: Sergei Trofimovich <slyfox@gentoo.org>
            ---
             configure.ac | 15 ++++++++-------
             1 file changed, 8 insertions(+), 7 deletions(-)

    * merge revision(s) 0df67a469561fab80b78478b99703ed893c4db07:

            Signal handler type should be void

            ---
             configure.ac                          |  1 -
             include/ruby/internal/intern/signal.h |  3 +--
             signal.c                              | 14 +++++++-------
             vm_core.h                             |  2 +-
             win32/Makefile.sub                    |  1 -
             5 files changed, 9 insertions(+), 12 deletions(-)

    * merge revision(s) 4d2ad8d737c55c3efd4c75131687dd1c8db7441b:

            Removed obsolete autoconf checks

            Use regular `AC_CHECK_MEMBERS` instead of:
            * `AC_STRUCT_ST_BLKSIZE`
            * `AC_STRUCT_ST_BLOCKS`
            * `AC_STRUCT_ST_RDEV`
            ---
             configure.ac         | 6 +++---
             missing/fileblocks.c | 1 -
             win32/Makefile.sub   | 1 -
             3 files changed, 3 insertions(+), 5 deletions(-)
             delete mode 100644 missing/fileblocks.c

    * merge revision(s) 3b7c05ef8dc15371316e5254d33af12928183971:

            Fixed RUBY_RM_RECURSIVE when autoconf met the required version

            Before 9189cf5793cd527a86b711d15d5fd0633ec082e1 the result of
            `m4_version_compare` was compared to -1, however the `$2` of
            `m4_version_prereq` has different meaning and is expanded when
            the required version met.
            ---
             tool/m4/ruby_rm_recursive.m4 | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

    * merge revision(s) c32375883a696fcf8e9e99875f1339ee5474a255,48bb0329eb325bc5b77c222f45b8dc97a208d986:

            Update for autoconf 2.70

            ---
             configure.ac                         | 232 +++++++++++++++++------------------
             tool/m4/ruby_check_builtin_setjmp.m4 |   8 +-
             tool/m4/ruby_check_printf_prefix.m4  |   9 +-
             tool/m4/ruby_check_setjmp.m4         |   6 +-
             tool/m4/ruby_check_sysconf.m4        |   6 +-
             tool/m4/ruby_cppoutfile.m4           |   4 +-
             tool/m4/ruby_decl_attribute.m4       |   4 +-
             tool/m4/ruby_dtrace_available.m4     |   2 +-
             tool/m4/ruby_dtrace_postprocess.m4   |   2 +-
             tool/m4/ruby_mingw32.m4              |   4 +-
             tool/m4/ruby_stack_grow_direction.m4 |   4 +-
             tool/m4/ruby_try_cflags.m4           |   2 +-
             tool/m4/ruby_try_cxxflags.m4         |   2 +-
             tool/m4/ruby_try_ldflags.m4          |   2 +-
             14 files changed, 143 insertions(+), 144 deletions(-)

            Revert AC_PROG_CC_C99 for -std=gnu99 option to gcc 4.8

            ---
             configure.ac | 5 ++++-
             1 file changed, 4 insertions(+), 1 deletion(-)

    Co-authored-by: Sergei Trofimovich <slyfox@gentoo.org>

commit fd95a1805922d9fbe65e6f4c08609c7eac10b723
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-05-31 23:01:45 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-05-31 23:01:45 +0900

    merge revision(s) d8a13e504992a45d52063f7c925408d7aad3595a: [Backport #17780]

            [Bug #17780] Fix Method#super_method for module alias

            Method#super_method crashes for aliased module methods because they are
            not defined on a class. This bug was introduced in
            c60aaed1856b2b6f90de0992c34771830019e021 as part of bug #17130.
            ---
             proc.c                   |  2 +-
             test/ruby/test_method.rb | 13 +++++++++++++
             2 files changed, 14 insertions(+), 1 deletion(-)

commit 67f1cd20bfb97ff6e5a15d27c8ef06cdb97ed37a
  Author:     NAKAMURA Usaku <usa@ruby-lang.org>
  AuthorDate: 2021-04-16 05:30:08 +0900
  Commit:     NAKAMURA Usaku <usa@ruby-lang.org>
  CommitDate: 2021-04-16 05:30:08 +0900

    merge revision(s) fbbc37dc1d5b329777e6d9716118db528ab70730: [Backport #17802]

            test/drb/test_drb.rb: Specify the host of DRbServer

            to try fixing the following error.

            http://rubyci.s3.amazonaws.com/opensuseleap/ruby-master/log/20210407T063004Z.log.html.gz
            ```
            [  605/21105] DRbTests::TestDRbSSLAry#test_06_next/home/chkbuild/chkbuild/tmp/build/20210407T063004Z/ruby/lib/drb/drb.rb:1138:in `method_missing': undefined method `regist' for [1, 2, "III", 4, "five", 6]:Array (NoMethodError)
                    from /home/chkbuild/chkbuild/tmp/build/20210407T063004Z/ruby/lib/drb/extserv.rb:21:in `block in initialize'
                    from /home/chkbuild/chkbuild/tmp/build/20210407T063004Z/ruby/.ext/common/monitor.rb:202:in `synchronize'
                    from /home/chkbuild/chkbuild/tmp/build/20210407T063004Z/ruby/.ext/common/monitor.rb:202:in `mon_synchronize'
                    from /home/chkbuild/chkbuild/tmp/build/20210407T063004Z/ruby/lib/drb/extserv.rb:20:in `initialize'
                    from /home/chkbuild/chkbuild/tmp/build/20210407T063004Z/ruby/test/drb/ut_array_drbssl.rb:35:in `new'
                    from /home/chkbuild/chkbuild/tmp/build/20210407T063004Z/ruby/test/drb/ut_array_drbssl.rb:35:in `<main>'
             = 100.05 s
            ```

            Here is my analysis:
            The test of drb used both `druby://:0` and `druby://localhost:0` for
            DRbServer. However, the former listens on IPv4, and the latter does on
            IPv6, depending on environments. The port 0 is automatically assigned,
            but sometimes the same port is used to both because they are different
            protocols (IPv4 and IPv6). In this case, their URIs are resolved to the
            completely same one (`druby://localhost:port`), which confuses the
            method `DRb.here?` which determines the DRbObject is remote or local.

            This changeset uses `druby://localhost:0` consistently.
            ---
             test/drb/test_drb.rb    | 4 ++--
             test/drb/test_drbssl.rb | 2 +-
             2 files changed, 3 insertions(+), 3 deletions(-)

commit 06732f8a1cbb69576de6383e55e2ddb976c63b34
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-04-05 23:31:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-05 23:31:27 +0900

    bump teeny version to 2.7.4.

commit 6847ee089d7655b2a0eea4fee3133aeacd4cc7cc
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-04-05 21:39:38 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-05 21:39:38 +0900

    merge revision(s) 856a9701fd13edbb9d5f0fa773082d312195df90:

            Get rid of multibyte prefix to tmpdir

            ---
             test/ruby/test_require.rb | 12 ++++++------
             1 file changed, 6 insertions(+), 6 deletions(-)

commit 59cfa0b1346067e36ae11fc6c317693ce4b9833a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-04-05 20:35:34 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-05 20:48:25 +0900

    Backport a tmpdir fix.

    Remove other then alphanumeric and some punctuations considered
    filesystem-safe, instead of removing some unsafe chars only.

commit b59e5a64be40b93370afbb0accfcb73c4d682045
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-04-05 20:14:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-04-05 20:14:49 +0900

    Backport rexml upstream bug fixes.

commit c761586ba9f87d96af804dc37458068d1facd7d3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-21 14:43:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-21 14:43:16 +0900

    I gave up tentatively to support autoconf 2.70 in ruby_2_7 and remove failing build on GitHub Actions MinGW

commit 338d7ec902a7c4c5367c6ac6d05602054f4fa250
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2021-03-21 14:27:46 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2021-03-21 14:27:46 +0900

    * 2021-03-21 [ci skip]

commit ad8d6dcb48a07caf7adb1dbc9df157149f0dee01
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-21 14:27:23 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-21 14:27:23 +0900

    Revert "merge revision(s) c32375883a696fcf8e9e99875f1339ee5474a255:"

    This reverts commit cfd1a17292ae37db4d09c1452a4a84e7fd58e7cf.

commit cfd1a17292ae37db4d09c1452a4a84e7fd58e7cf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-21 14:19:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-21 14:19:35 +0900

    merge revision(s) c32375883a696fcf8e9e99875f1339ee5474a255:

            Update for autoconf 2.70

            ---
             configure.ac                         | 232 +++++++++++++++++------------------
             tool/m4/ruby_check_builtin_setjmp.m4 |   8 +-
             tool/m4/ruby_check_printf_prefix.m4  |   9 +-
             tool/m4/ruby_check_setjmp.m4         |   6 +-
             tool/m4/ruby_check_sysconf.m4        |   6 +-
             tool/m4/ruby_cppoutfile.m4           |   4 +-
             tool/m4/ruby_decl_attribute.m4       |   4 +-
             tool/m4/ruby_dtrace_available.m4     |   2 +-
             tool/m4/ruby_dtrace_postprocess.m4   |   2 +-
             tool/m4/ruby_mingw32.m4              |   4 +-
             tool/m4/ruby_stack_grow_direction.m4 |   4 +-
             tool/m4/ruby_try_cflags.m4           |   2 +-
             tool/m4/ruby_try_cxxflags.m4         |   2 +-
             tool/m4/ruby_try_ldflags.m4          |   2 +-
             14 files changed, 143 insertions(+), 144 deletions(-)

commit 16f3ebd77b31ffe9457566e13bb7b9c4fdefd4a5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 16:41:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 16:41:13 +0900

    merge revision(s) 737da8d383e116c83fb356386322626f039deb06:

            Add another missing cast

            ---
             iseq.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 23bb717d95bd087dd0ec6a1beeed1b28eccc0f5b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 16:38:26 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 16:38:26 +0900

    Partially merged 79df14c04b452411b9d17e26a398e491bca1a811 to suppress compiler warning.

commit 364c8595884808315aaec9605bf2423963ed81c0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 16:16:45 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 16:16:45 +0900

    merge revision(s) a85ed626f18d1014d09fb37eb0a703976c3d2b53: [Backport #17731]

            Fix Enumerable#inject with high negative fixnums [Bug #17731]

            ---
             enum.c                 | 2 +-
             test/ruby/test_enum.rb | 2 ++
             2 files changed, 3 insertions(+), 1 deletion(-)

commit ec779aa56f4d6df465e721818d73d0d48fdf03f2
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 16:15:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 16:15:35 +0900

    merge revision(s) f748b911c9157a0bb86f38280ddfba72a55049b6: [Backport #17729]

            Fix infinite loop at illegal sequence [Bug #17729]

            As mblen returns -1 on failure, skip the first byte and try the
            succeeding bytes in that case.

            Close https://github.com/ruby/ruby/pull/4281
            ---
             eval_intern.h                 | 11 ++++++++++-
             test/ruby/test_rubyoptions.rb |  5 +++++
             2 files changed, 15 insertions(+), 1 deletion(-)

commit 6e962f02b266c3a6c47e50cf2e9ab7b1db25e515
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 16:14:18 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 16:14:18 +0900

    merge revision(s) 58660e943488778563b9e41005a601e9660ce21f: [Backport #17519]

            Skip refined method when exporting methods with changed visibility

            Previously, attempting to change the visibility of a method in a
            singleton class for a class/module that is prepended to and refined
            would raise a NoMethodError.

            Fixes [Bug #17519]
            ---
             test/ruby/test_module.rb | 23 +++++++++++++++++++++++
             vm_method.c              | 14 +++++++++++---
             2 files changed, 34 insertions(+), 3 deletions(-)

commit ce02265d59af720e38cdade0c90f50b0408f27a8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 16:04:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 16:04:02 +0900

    merge revision(s) 0dc95266e8c36dbc3bfdcb88d820cb7f897166d7:

            Fix the failing test with XDG_CONFIG_HOME

            ---
             test/irb/test_init.rb | 4 ++++
             1 file changed, 4 insertions(+)

commit 755a349a3a66f5731995296fe3bb7d2b1712167f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 15:54:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 15:54:03 +0900

    merge revision(s) 4bff8e84232594ecb9914e2a8437b7c40a63b799: [Backport #16814]

            Ensure that the head of the vacancy list is correctly inserted into
             the linked list.

            See <https://bugs.ruby-lang.org/issues/16814> for more details.
            ---
             cont.c | 1 +
             1 file changed, 1 insertion(+)

commit 82bce422ba9e131e62b528854dea69a6e8cc0c04
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 15:35:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 15:35:30 +0900

    merge revision(s) 254bed302752a401b5fcc3b6c65a9c93711d91d6,fad3023e94c45e7f03478732f7641b6f39ba9d12,3156fb0f2c3ebf8229f392c8502c08fe165ab181: [Backport #17218]

            Renamed `nurat_sub` compliant with `rb_rational_plus`

            ---
             internal/rational.h | 1 +
             rational.c          | 6 +++---
             2 files changed, 4 insertions(+), 3 deletions(-)

            Fix ArithmeticSequence#last and ArithmeticSequence#each for
             non-integer sequences (#3870)

            [Bug #17218]
            [ruby-core:100312]
            ---
             common.mk                             |  2 +
             enumerator.c                          | 99 ++++++++++++++++++++++++++++++++---
             internal/numeric.h                    |  2 +
             internal/rational.h                   |  2 +
             numeric.c                             | 53 ++++++++++---------
             rational.c                            | 28 +++++++---
             test/ruby/test_arithmetic_sequence.rb | 10 ++++
             7 files changed, 156 insertions(+), 40 deletions(-)

            test/ruby/test_arithmetic_sequence.rb: remove a duplicated test

            There is another "test_last_bug17218"
            ---
             test/ruby/test_arithmetic_sequence.rb | 5 -----
             1 file changed, 5 deletions(-)

commit c02f4c1c5aa5056d6eae8f0c2d6414adf5293b2b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 15:01:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 15:01:48 +0900

    merge revision(s) e0dd072978e6c2c8180e75617e7ee37830caefa3,85f99f4b715a5954124d5014002c16652995b128:

            Fix errors when XDG_CONFIG_HOME points to non-writable directory

            `$HOME/.config` is not writable on CI
            because I think tests should not corrupt user's data.

            And GitHub Actions CI sets `XDG_CONFIG_HOME`
            since `Version: 20210309.1`.

            https://github.com/ruby/actions/runs/2130811016?check_suite_focus=true#step:16:301
            ```
            Errno::EACCES: Permission denied @ dir_s_mkdir - /home/runner/.config/irb
            ```
            ---
             test/irb/test_cmd.rb | 2 ++
             1 file changed, 2 insertions(+)

            Try to fix errors in TestIRB::TestHistory too

            https://github.com/ruby/actions/runs/2137935523?check_suite_focus=true#step:9:562
            ```
              1) Error:
            TestIRB::TestHistory#test_history_concurrent_use:
            Errno::EACCES: Permission denied @ dir_s_mkdir - /home/runner/.config/irb
                /home/runner/work/actions/actions/ruby/lib/fileutils.rb:253:in `mkdir'
                /home/runner/work/actions/actions/ruby/lib/fileutils.rb:253:in `fu_mkdir'
                /home/runner/work/actions/actions/ruby/lib/fileutils.rb:231:in `block (2 levels) in mkdir_p'
                /home/runner/work/actions/actions/ruby/lib/fileutils.rb:229:in `reverse_each'
                /home/runner/work/actions/actions/ruby/lib/fileutils.rb:229:in `block in mkdir_p'
                /home/runner/work/actions/actions/ruby/lib/fileutils.rb:211:in `each'
                /home/runner/work/actions/actions/ruby/lib/fileutils.rb:211:in `mkdir_p'
                /home/runner/work/actions/actions/ruby/lib/irb/init.rb:355:in `rc_file_generators'
                /home/runner/work/actions/actions/ruby/lib/irb/init.rb:330:in `rc_file'
                /home/runner/work/actions/actions/ruby/test/irb/test_history.rb:170:in `block in assert_history'
                /home/runner/work/actions/actions/ruby/lib/tmpdir.rb:96:in `mktmpdir'
                /home/runner/work/actions/actions/ruby/test/irb/test_history.rb:168:in `assert_history'
                /home/runner/work/actions/actions/ruby/test/irb/test_history.rb:133:in `test_history_concurrent_use'
            ```
            ---
             test/irb/test_history.rb | 2 ++
             1 file changed, 2 insertions(+)

commit d84cc717020be1da7d89b6bda02d1427f9593968
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 14:57:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 14:57:33 +0900

    merge revision(s) 15e23312f6abcbf1afc6fbbf7917a57a0637f680: [Backport #16809]

            Rework the order of operations to avoid stack smashing.

            ---
             coroutine/copy/Context.c | 59 ++++++++++++++++++++++++++++++++----------------
             1 file changed, 40 insertions(+), 19 deletions(-)

commit a85982553935b81de02eb8cca9476df5d4442fd8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 14:43:10 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 14:43:10 +0900

    merge revision(s) 276f6a225d18561cbe5282b798cb4e416c66079f,95bef7b69a6fb42687a6200b338060be307259f5: [Backport #17352]

            Don't double fractional seconds when passing timezone object to
             Time.new

            I found that fractional seconds were doubled when using the timezone
            feature of Time in Sequel's named_timezones extension (which uses
            TZInfo for the timezone object), and traced the problem to this code.

            There is no subsecx being modified in the utc_to_local call below
            this, and I'm not sure why you would want to add in the fractional
            seconds unless you assumed the timezone conversion would drop the
            existing fractional seconds (TZInfo doesn't drop fractional seconds).
            ---
             test/ruby/test_time_tz.rb | 10 ++++++++++
             1 file changed, 10 insertions(+)

            Subsecond of Time::tm should be 0

            ---
             time.c | 1 +
             1 file changed, 1 insertion(+)

commit 82d72f14e7071218f3fd710f770d1ba31390f027
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 14:26:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 14:26:30 +0900

    merge revision(s) ebb96fa8808317ad53a4977bff26cf755d68077e: [Backport #17321]

            Fix singleton class cloning

            Before this commit, `clone` gave different results depending on whether the original object
            had an attached singleton class or not.

            Consider the following setup:
            ```
            class Foo; end
            Foo.singleton_class.define_method(:foo) {}

            obj = Foo.new

            obj.singleton_class if $call_singleton

            clone = obj.clone
            ```

            When `$call_singleton = false`, neither `obj.singleton_class.singleton_class` nor
            `clone.singleton_class.singleton_class` own any methods.

            However, when `$call_singleton = true`, `clone.singleton_class.singleton_class` would own a copy of
            `foo` from `Foo.singleton_class`, even though `obj.singleton_class.singleton_class` does not.

            The latter case is unexpected and results in a visibly different clone, depending on if the original object
            had an attached class or not.

            Co-authored-by: Ufuk Kayserilioglu <ufuk.kayserilioglu@shopify.com>
            ---
             class.c                 | 31 ++++++++++++++++++++++---------
             test/ruby/test_class.rb | 47 +++++++++++++++++++++++++++++++++++++++++++++++
             2 files changed, 69 insertions(+), 9 deletions(-)

commit 6ef46f71c743507a0e2ae0eef14dce0539b0ff52
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 14:23:45 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 14:23:45 +0900

    merge revision(s) 511b55bcefc81c036294dc9a544d14bd342acd3b: [Backport #17215]

            Enable arm64 optimizations that exist for power/x86 (#3393)

            * Enable unaligned accesses on arm64

            64-bit Arm platforms support unaligned accesses.

            Running the string benchmarks this change improves performance
            by an average of 1.04x, min .96x, max 1.21x, median 1.01x

            * arm64 enable gc optimizations

            Similar to x86 and powerpc optimizations.

            |       |compare-ruby|built-ruby|
            |:------|-----------:|---------:|
            |hash1  |       0.225|     0.237|
            |       |           -|     1.05x|
            |hash2  |       0.110|     0.110|
            |       |       1.00x|         -|

            * vm_exec.c: improve performance for arm64

            |                               |compare-ruby|built-ruby|
            |:------------------------------|-----------:|---------:|
            |vm_array                       |     26.501M|   27.959M|
            |                               |           -|     1.06x|
            |vm_attr_ivar                   |     21.606M|   31.429M|
            |                               |           -|     1.45x|
            |vm_attr_ivar_set               |     21.178M|   26.113M|
            |                               |           -|     1.23x|
            |vm_backtrace                   |       6.621|     6.668|
            |                               |           -|     1.01x|
            |vm_bigarray                    |     26.205M|   29.958M|
            |                               |           -|     1.14x|
            |vm_bighash                     |    504.155k|  479.306k|
            |                               |       1.05x|         -|
            |vm_block                       |     16.692M|   21.315M|
            |                               |           -|     1.28x|
            |block_handler_type_iseq        |       5.083|     7.004|
            |                               |           -|     1.38x|
            ---
             gc.c                           | 13 +++++++++++++
             gc.h                           |  2 ++
             include/ruby/internal/config.h |  2 ++
             regint.h                       |  2 +-
             siphash.c                      |  2 +-
             st.c                           |  2 +-
             vm_exec.c                      |  8 ++++++++
             7 files changed, 28 insertions(+), 3 deletions(-)

commit ef1ed1b53afdff80cb217d77f3fbcbe7906c729e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 13:56:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 13:56:13 +0900

    merge revision(s) c15cddd1d515c5bd8dfe8fb2725e3f723aec63b8: [Backport #16787]

            Allow Dir.home to work for non-login procs when $HOME not set

            Allow the 'Dir.home' method to reliably locate the user's home directory when
            all three of the following are true at the same time:

                1. Ruby is running on a Unix-like OS
                2. The $HOME environment variable is not set
                3. The process is not a descendant of login(1) (or a work-alike)

            The prior behavior was that the lookup could only work for login-descended
            processes.

            This is accomplished by looking up the user's record in the password database
            by uid (getpwuid_r(3)) as a fallback to the lookup by name (getpwname_r(3))
            which is still attempted first (based on the name, if any, returned by
            getlogin_r(3)).

            If getlogin_r(3), getpwnam_r(3), and/or getpwuid_r(3) is not available at
            compile time, will fallback on using their respective non-*_r() variants:
            getlogin(3), getpwnam(3), and/or getpwuid(3).

            The rationale for attempting to do the lookup by name prior to doing it by uid
            is to accommodate the possibility of multiple login names (each with its own
            record in the password database, so each with a potentially different home
            directory) being mapped to the same uid (as is explicitly allowed for by
            POSIX; see getlogin(3posix)).

            Preserves the existing behavior for login-descended processes, and adds the
            new capability of having Dir.home being able to find the user's home directory
            for non-login-descended processes.

            Fixes [Bug #16787]

            Related discussion:
                https://bugs.ruby-lang.org/issues/16787
                https://github.com/ruby/ruby/pull/3034
            ---
             configure.ac       |   5 +
             file.c             |  51 +++++++---
             internal/process.h |   6 ++
             process.c          | 266 ++++++++++++++++++++++++++++++++++++++++++++++++++++-
             4 files changed, 311 insertions(+), 17 deletions(-)

commit ba6f0879448ebc80c7a595c369c59b6d8dfbdf3e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 13:33:52 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 13:33:52 +0900

    merge revision(s) abe2e7de4d1f2d5861d7c9ab9c7e778f2ee1dcd2: [Backport #16774]

            Don't require sub-word atomics

            On some architectures (like RISC-V) sub-word atomics are only available
            when linking against -latomic, but the configure script doesn't do that,
            causing the atomic checks to fail and the resulting ruby binary is
            non-functional.  Ruby does not use sub-word atomic operations, rb_atomic_t
            is defined to unsigned int, so use unsigned int when checking for atomic
            operations.
            ---
             configure.ac | 4 ++--
             1 file changed, 2 insertions(+), 2 deletions(-)

commit c98aa2db60f43e839d7a82897c22b5ceecbed417
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 13:29:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 13:29:39 +0900

    merge revision(s) c60aaed1856b2b6f90de0992c34771830019e021: [Backport #17130]

            Fix Method#super_method for aliased methods

            Previously, Method#super_method looked at the called_id to
            determine the method id to use, but that isn't correct for
            aliased methods, because the super target depends on the
            original method id, not the called_id.

            Additionally, aliases can reference methods defined in other
            classes and modules, and super lookup needs to start in the
            super of the defined class in such cases.

            This adds tests for Method#super_method for both types of
            aliases, one that uses VM_METHOD_TYPE_ALIAS and another that
            does not.  Both check that the results for calling super
            methods return the expected values.

            To find the defined class for alias methods, add an rb_ prefix
            to find_defined_class_by_owner in vm_insnhelper.c and make it
            non-static, so that it can be called from method_super_method
            in proc.c.

            This bug was original discovered while researching [Bug #11189].

            Fixes [Bug #17130]
            ---
             proc.c                   | 13 ++++++--
             test/ruby/test_method.rb | 80 ++++++++++++++++++++++++++++++++++++++++++++++++
             vm_insnhelper.c          |  6 ++--
             3 files changed, 94 insertions(+), 5 deletions(-)

commit 70c3a195f39763dccdf9367d0c9b7e815431a41a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 13:18:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 13:18:32 +0900

    merge revision(s) 9682db065158da5fa4ec8a3bc267da45b429b92c: [Backport #12838] [Backport #17658]

            Remove sender/message_id pair after response received in resolv

            Once a response for a given DNS request has been received (which
            requires a matching message id), the [sender, message_id] pair
            should be removed from the list of valid senders.  This makes it
            so duplicate responses from the same sender are ignored.

            Fixes [Bug #12838]
            ---
             lib/resolv.rb           |   2 +-
             test/resolv/test_dns.rb | 113 ++++++++++++++++++++++++++++++++++++++++++++++++
             2 files changed, 114 insertions(+), 1 deletion(-)

commit 9994860dcb56697fad1799128d1493adc06b23c7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 13:02:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 13:02:33 +0900

    merge revision(s) 2a6bfd22468343003463e0cbf91953a01b0dbba5,3ac28de5414c81a0da8c8ec969ea74db5a0f1b0f: [Backport #17645]

            Properly convert time_t [Bug #17645]

            ---
             thread_sync.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

            Explicitly cast __s64 to time_t [Bug #17645]

            A workaround of shorten-64-to-32 error where 32-bit linux.
            ---
             file.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 30942fc4d89a04792e9eba7d3c4e5009c54e81da
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-03-20 12:49:24 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-03-20 12:49:24 +0900

    merge revision(s) 2a83650b0fd25719fb6c03bfec7bd895734d3ceb: [Backport #15852]

            Destroy VM-wise locks before freeing [Bug #15852]

            ---
             thread.c | 7 -------
             vm.c     | 2 ++
             2 files changed, 2 insertions(+), 7 deletions(-)

commit bad623558eafde1f2ea23d27afdfa6b1690ee16f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-02-27 13:49:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-02-27 13:49:03 +0900

    .github/workflows/macos.yml: Remove pre-installed gems before test on macos Actions.

commit 190ffd8761bec206582095028e5752ae5ccd7587
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-02-27 13:46:28 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-02-27 13:46:28 +0900

    merge revision(s) f4be7a510eebbe6507ba41d138d7d252f4a68e90,9441f3f97087a4325ee80911859d37da41fa5050: [Backport #17504]

            Added tests for Time#getlocal with UTC offset

            ---
             test/ruby/test_time.rb | 8 ++++++++
             1 file changed, 8 insertions(+)

            Allow UTC offset without colons per ISO-8601 [Bug #17504]

            ---
             test/ruby/test_time.rb |  6 ++++++
             time.c                 | 44 +++++++++++++++++++++++++++++---------------
             2 files changed, 35 insertions(+), 15 deletions(-)

commit 931815bfd86df603337194f3fcefb46bfe3e7940
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-02-20 18:46:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-02-20 18:46:40 +0900

    merge revision(s) eeacdcb9a073c7d8ad703e0dc9faf229a5ebbe3c: [Backport #17558]

            Fixed premature return

            After setting ruby2_keywords for bmethod, the rest of arguments
            had been ignored. [Bug #17558]
            ---
             test/ruby/test_keyword.rb | 9 +++++++++
             vm_method.c               | 2 +-
             2 files changed, 10 insertions(+), 1 deletion(-)

commit 0cfd491732162eab61227ac4b49617c37ddbb316
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-02-20 18:06:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-02-20 18:06:43 +0900

    merge revision(s) 9241211538189a58b477bd55b539357617fd42ed: [Backport #17589]

            Forward keyword arguments for Pathname#each_line [Bug #17589]

            ---
             ext/pathname/pathname.c        |  4 ++--
             test/pathname/test_pathname.rb | 26 ++++++++++++++++++++++++++
             2 files changed, 28 insertions(+), 2 deletions(-)

commit 3d39ad217866138de1d3597440ef6358690b3435
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-02-20 17:56:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-02-20 17:56:14 +0900

    merge revision(s) 0036648a420f945624898568bb82bc5f83195d12: [Backport #17533]

            Capture to reserved name variables if already defined [Bug #17533]

            ---
             parse.y                  |  5 +++--
             test/ruby/test_regexp.rb | 11 +++++++++++
             2 files changed, 14 insertions(+), 2 deletions(-)

commit 14823c2d7c20dba288025749b4d55c02d8729871
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-02-20 17:29:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-02-20 17:29:32 +0900

    merge revision(s) 6f6dfdcc685077f0f85dcdd63843ecfc0f6fbfb6: [Backport #17523]

            Make warning values consistent [Bug #17523]

            They should be affected, as well as `$VERBOSE`, by `-w`/`-W`
            options, not only in the main script but in scripts loaded by `-r`
            option too.
            ---
             ruby.c                        | 4 ++--
             test/ruby/test_rubyoptions.rb | 9 +++++++++
             2 files changed, 11 insertions(+), 2 deletions(-)

commit 69d01653f831052acdc803aad0b78690ad61ca86
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-02-20 12:12:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-02-20 12:12:35 +0900

    merge revision(s) 1b1ea7b3bc9484e6e59d716fce2965a2f39d1e3d,b6e6807993c770c5d2e069d8741f5dadf0b38069: [Backport #17092]

            Fix Array#flatten for recursive array when given positive depth [Bug
             #17092]

            ---
             array.c                 | 44 ++++++++++++++++++++++++++------------------
             test/ruby/test_array.rb | 14 +++++++++++---
             2 files changed, 37 insertions(+), 21 deletions(-)

            Initialize memo pointer and use it consistently to silence gcc 7+

            ---
             array.c | 10 +++++-----
             1 file changed, 5 insertions(+), 5 deletions(-)

commit ea222b05571741f36b59f615c2e83b3adafbd398
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-02-11 14:13:56 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-02-11 14:13:56 +0900

    merge revision(s) 49d3830f44031174ad450a0ea1cdcdf0eabf9d0e: [Backport #17560]

            Fix documentation for Module#ruby2_keywords

            It returns nil, not self.

            Fixes [Bug #17560]
            ---
             vm_method.c | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit f03ba00f40e7c964efcfffc7a761074800ecc1a4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-02-11 13:35:28 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-02-11 13:52:14 +0900

    merge revision(s) 43a9a974e276dc49b03ec81ccace0adb534a3d20: [Backport #17021] [Backport #17605]

            [Bug #17021] Make host_* values consistent with target_*

            ---
             configure.ac | 7 ++++++-
             1 file changed, 6 insertions(+), 1 deletion(-)

commit 4b6df7f735c10f326f09a44fe38dc10b05ced21c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-02-11 13:34:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-02-11 13:52:00 +0900

    merge revision(s) a55eb9a2af7950d180d9d31ffde2bce66710f44f: [Backport #17572]

            Make reciprocal properly of non-integral rational [Bug #17572]

            ---
             rational.c                 | 2 +-
             test/ruby/test_rational.rb | 7 +++++++
             2 files changed, 8 insertions(+), 1 deletion(-)

commit 9cc8b2a672f50fa9a849105353e332d3a72d7b28
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-02-11 13:30:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-02-11 13:51:43 +0900

    merge revision(s) e033c9d7db02a4e8d2973364ecb47744b63aecd3: [Backport #17549]

            Include missing AvailabilityMacros.h

            ---
             random.c | 4 ++++
             1 file changed, 4 insertions(+)

commit f49355a720afe492ea49809e469dce36a9ea961a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-02-11 13:29:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-02-11 13:51:09 +0900

    merge revision(s) 555bd83a8e8b1e859f698089cbbd9ad938159a0e: [Backport #17192]

            Raise when loading unprovided builtin function [Bug #17192]

            ---
             compile.c              |  7 +++----
             test/ruby/test_iseq.rb | 15 +++++++++++++++
             2 files changed, 18 insertions(+), 4 deletions(-)

commit c271c7a225c6175f56f00b785e3034cb4a2b7658
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-02-11 12:52:11 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-02-11 12:52:11 +0900

    merge revision(s) ce7a053475cbebfb2f3e5ed6614e0ba631541917,1cbb1f1720127b0b34b38c77e27b51b182008699: [Backport #16695]

            Adjust sp for `x = false; y = (return until x unless x)` [Bug #16695]

            ---
             compile.c                | 8 +++-----
             test/ruby/test_syntax.rb | 9 +++++++++
             2 files changed, 12 insertions(+), 5 deletions(-)

            test/ruby/test_syntax.rb: avoid "warning: assigned but unused
             variable"

            ---
             test/ruby/test_syntax.rb | 2 +-
             1 file changed, 1 insertion(+), 1 deletion(-)

commit 29bc77f780bbefca60724e52129f5229aa373551
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-02-11 12:31:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-02-11 12:31:21 +0900

    merge revision(s) 9fb60672d55162a92ab7e97b000a7e277458aab1: [Backport #17313]

            Fix a use-after-free bug reported by ASAN

            If a fiber and thread are collected at the same time, the thread might
            get collected first and the pointer on the fiber will go bad.  I don't
            think we need to check whether or not this is the main fiber in order to
            release its stack
            ---
             cont.c | 4 +---
             1 file changed, 1 insertion(+), 3 deletions(-)

commit 7332b3f367ce61089bf571fa1c458fde06a11eab
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-01-30 20:52:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-01-30 20:52:15 +0900

    merge revision(s) b091889ed67f278b1652ddde88596e2160d5aef0: [Backport #17582]

            Removed YYUSE [Bug #17582]

            Although it was used just to suppress an "unsed argument" warning
            in the same manner as other bison-provided functions, it has been
            dropped since Bision 3.7.5.  And we always suppress that
            warnings.
            ---
             parse.y | 1 -
             1 file changed, 1 deletion(-)

commit 99b4f20fd65075d2d9ee02f8c7a6b5d6a914ce31
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2021-01-30 20:43:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2021-01-30 20:43:44 +0900

    Merge RubyGems-3.1.6 [Bug #16926]
    https://github.com/ruby/ruby/pull/4122

commit d0693391103672b7fc3976e5ae8ae414059b3e97
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-12-31 18:34:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-12-31 18:34:09 +0900

    merge revision(s) ed549f80b645aafd62376f65c3a27b66bafa2a38,eff0c5bf2ad47d10a440c5211be5eddb3bbf4028,f6b6a7ad345c50eeb3f7206ceabdf41ba94b7d85,5b48686691c2443d8d7113e593494c4d9302da0e,2af4c1fc5b19fc96203c2d7e917e689510d3527e,c9213aa864fb8527388679c21f1ea8ce129e2f1a,224f29c8e92094af10bc666c474b81a3545d6adf:

            spec/ruby/core/process/clock_getres_spec.rb: skip on Android

            in the same way as FreeBSD and OpenBSD.
            I guess that the spec makes too strong assumption.

            Try to avoid random failures on clock_getres_spec.rb

            This spec fails too often
            https://github.com/ruby/ruby/runs/529546249
            https://github.com/ruby/ruby/runs/524933256

            Show failed times

            Remove Process.clock_getres "matches the resolution in practice"
             specs

            * Almost all platforms return incorrect values for Process.clock_getres,
              it should be removed: https://bugs.ruby-lang.org/issues/16740

            Skip Process#clock_getres specs on Android

            ... just like AIX and OpenBSD.

            Update to ruby/spec@d394dfd

            spec/ruby/core/process/clock_getres_spec.rb: lax the resolution limit

            Android is Linux, but the clock resolution is 10 milliseconds.
            I think that 1 microsecond is too strict for embedded environment.
            This change laxes the limit to 10 milliseconds.

commit 5cbba4d6005a03914fc47e7a65ae5b6ef76c8e29
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-12-31 15:40:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-12-31 15:40:30 +0900

    merge revision(s) 1ca9facab6c85264168b4c0a18c24f489cabcc9f: [Backport #17358]

            Add monitor to document files

commit 9eff912943a71745087ea4ae892774e33bd2e8ca
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-12-31 15:39:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-12-31 15:39:01 +0900

    merge revision(s) 8b0dc77a621ded75f72486c33f55404ce73f00d7: [Backport #17275]

            configure.ac: Bump the size of sigaltstack

            The RubyVM uses C macro defines to feature detect whether
            `backtrace(2)` support is available, and if so it includes C level backtraces
            when the RubyVM itself crashes.

            But on my machine, C level backtraces from `vm_dump.c` didn't work when
            using a version of Ruby buillt on the machine, but worked fine when using a
            version of Ruby built on another machine and copied to my machine.

            The default autoconf test for backtraces uses a sigaltstack size that is
            too small, so the SIGSEGV signal handler itself causes a SIGSEGV).
            I noticed that signal.c uses a larger sigaltstack size:

            https://github.com/ruby/ruby/blob/v2_6_5/signal.c#L568

            The specific variables it looks at:

            - `HAVE_BACKTRACE`

              this is a macro defined by autoconf because there is a line in the
              configure script like `AC_CHECK_FUNCS(backtrace)` (see the autoconf
              docs for more).

            - `BROKEN_BACKTRACE`

              this comes from a custom program that Ruby's configure script runs to
              attempt to figure out whether actually using backtrace(2) in a real
              program works. You can see the autoconf program here.

              <https://github.com/ruby/ruby/blob/v2_6_5/configure.ac#L2817-L2863>

            It uses sigaltstack and SA_ONSTACK to create a seperate stack for
            handling signals.

            The problem was: SIGSTKSZ (which comes from a system header!) was not
            suggesting a large enough stack size. When checking on an Ubuntu 16.04
            box, we found that SIGSTKSZ was 8192 and MINSIGSTKSZ was 2048.

commit 16930b254b4e5397759d6b42845b495041b71321
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-12-31 15:37:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-12-31 15:37:15 +0900

    merge revision(s) be9dbe1c3eb4bb4cab0bdc42a91ef425bb1eaddd: [Backport #15178]

            Fix pthread_setname_np arguments on NetBSD

            The previous attempt to fix this in
            b87df1bf243074edb2e6cc8a24bc00df81cebf3c reversed the argument
            order instead of just fixing the quote escaping.

            From Takahiro Kambe.

            Fixes [Bug #15178]

commit 27fca66207f2c35f2f44f6a7cbbe6fd153546082
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-12-31 15:19:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-12-31 15:19:16 +0900

    Add leading arguments support to arguments forwarding

    Implements [Feature #16378]

commit e249f37f24ffa207a5e67f85306f3266aff18429
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-12-31 15:10:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-12-31 15:10:19 +0900

    merge revision(s) 45fd4436ee146f95487b1575c5a2df5cf77f4717:

            Use $GITHUB_ENV instead of set-env

            https://github.blog/changelog/2020-10-01-github-actions-deprecating-set-env-and-add-path-commands/

commit 9b884df6dd918b0fdcc256d8a9febfaccd8a9042
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-12-09 20:33:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-12-09 20:34:55 +0900

    Update rubygems to 3.1.5. [Bug #17381]

    Add GlobalSign Root CA.
    https://github.com/rubygems/rubygems/pull/4100
    https://github.com/rubygems/rubygems/pull/4105

commit d1ba5545513b68d39ca29b578a42bd8d48a7804e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-10-11 15:41:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-10-11 15:41:57 +0900

    merge revision(s) 9718ff62c12c07ecf7f0e234343dca76ee1aa51d,20ad1017017ea736667d86fa0250dc1a39daefa1: [Backport #17211]

            Show stdout and stderr when history tests fail

            Remove system method for E2E testing because depends on ruby command

commit 48ac73769772317d6c3f864f087ef930a47120d9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-10-11 15:33:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-10-11 15:33:09 +0900

    Bump up webrick version to 1.6.1. [Bug #17201]

commit 0126c7dfa6f0ce83ac7815218397e0d0db251c6f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-10-11 15:29:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-10-11 15:29:00 +0900

    bump teeny version to 2.7.3.

commit 5445e0435260b449decf2ac16f9d09bae3cafe72
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-10-01 21:15:38 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-10-01 21:15:38 +0900

    merge revision(s) 0168094da28c146062db22e69cbd9316418310f9,cdef17096c03099f17ecf0af51f43faa0944f96d,b7d86e330c76b4f9615511307e1c40f4f2937c83:

            Use libSystem.dylib instead of libm.dylib and libc.dylib

              Because macOS 11.0(Big Sur) was removed libc and libm from `/usr/lib`.

            libSystem.dylib is also symlink. Use libSystem.B.dylib

            Workaroud for macOS Big Sur(11.0)

commit b35bfa6abb7760e4323a4341dff840f59ddcfde1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-10-01 21:02:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-10-01 21:02:05 +0900

    merge revision(s) 35ba2783fe6b3316a6bbc6f00bf975ad7185d6e0,e8edc34f0abe176b24975a1fed1f2c3782f0a252: [Backport #16807]

            Use a linked list to eliminate imemo tmp bufs for managing local
             tables

            This patch changes local table memory to be managed by a linked list
            rather than via the garbage collector.  It reduces allocations from the
            GC and also fixes a use-after-free bug in the concurrent-with-sweep
            compactor I'm working on.

            Remove unused struct member

            I accidentally added this in 35ba2783fe6b3316a6bbc6f00bf975ad7185d6e0,
            and it's making the size of RVALUE be too big. I'm sorry! orz

commit 811b2b0df5e670ad8db7951191232ce3f5b0d978
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-10-01 19:10:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-10-01 19:10:30 +0900

    bump teeny version to 2.7.2.

commit 229c041f057f24b8e5c0c911738e17dfb3da4515
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-10-01 07:53:55 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-10-01 07:53:55 +0900

    merge revision(s) d732bc51bdbfe7d66038731d42e01a511d13b5f8,633a1f15d8228236094ddee12e4e169d655ec49e,95f387f61a4a4ea92635da760b7de5b1e09bb84e,528a3a17977aa1843a26630c96635c3cb161e729,261569d4aac440f25de588cca365163ecf1124a2,e4a9e926f0fe0acf2fbe61da6e075a95d34be066,318be1cb2f9c6f04403c063a5618c6267012ee51,e1855100e46040e73630b378974c17764e0cccee,9cfa811b0f209d714f89fe0de6778c71f77556c7,b68dab866724aacc1cbc6b7d5e1f555dec092346: [Backport #17202]

            Revert "Revert "Revert "[ruby/fiddle] Use ffi_closure_free by
             default. (#20)"""

            This reverts commit 87f6154bb4c67ca77ee353bb1fe25a922036c0e5.

            It turned out that the change fails to build on macOS

            https://rubyci.org/logs/rubyci.s3.amazonaws.com/osx1014/ruby-master/log/20200304T074503Z.fail.html.gz
            ```
            + make 'TESTS=--hide-skip -v fiddle' RUBYOPT=-w test-all
            dyld: lazy symbol binding failed: Symbol not found: _ffi_closure_alloc
              Referenced from: /Users/hsbt/Documents/cb/tmp/build/20200304T074503Z/ruby/.ext/x86_64-darwin18/fiddle.bundle
              Expected in: flat namespace

            dyld: Symbol not found: _ffi_closure_alloc
              Referenced from: /Users/hsbt/Documents/cb/tmp/build/20200304T074503Z/ruby/.ext/x86_64-darwin18/fiddle.bundle
              Expected in: flat namespace

            make: *** [yes-test-all] Abort trap: 6
            ```

            [ruby/fiddle] Use ffi_closure_free if available

            [ruby/fiddle] ffi_closure_free is available in the bundled libffi

            [ruby/fiddle] use ffi_closure_alloc only with 3.2 or later

            [ruby/fiddle] always use ffi_closure_alloc on Windows

            Fixed a typo

            Show libffi version only if set

            ext/fiddle/extconf.rb: check if ffi_closure_alloc is available

            to define HAVE_FFI_CLOSURE_ALLOC.
            The macro is used in closure.c, so have_func check is needed.

            If pkg-config is not installed, extconf.rb fails to detect the version
            of libffi, and does not add "-DUSE_FFI_CLOSURE_ALLOC=1" even when system
            libffi version is >= 3.2.

            If USE_FFI_CLOSURE_ALLOC is not defined, closure.c attempts to check if
            HAVE_FFI_CLOSURE_ALLOC is defined or not, but have_func was removed with
            528a3a17977aa1843a26630c96635c3cb161e729, so the macro is always not
            defined.

            This resulted in this deprecation warning:

            https://rubyci.org/logs/rubyci.s3.amazonaws.com/ubuntu2004/ruby-master/log/20200512T123003Z.log.html.gz
            ```
            compiling closure.c
            closure.c: In function 'initialize':
            closure.c:265:5: warning: 'ffi_prep_closure' is deprecated: use ffi_prep_closure_loc instead [-Wdeprecated-declarations]
              265 |     result = ffi_prep_closure(pcl, cif, callback, (void *)self);
                  |     ^~~~~~
            In file included from ./fiddle.h:42,
                             from closure.c:1:
            /usr/include/x86_64-linux-gnu/ffi.h:334:1: note: declared here
              334 | ffi_prep_closure (ffi_closure*,
                  | ^~~~~~~~~~~~~~~~
            ```

            Do not try ffi_closure_alloc if libffi is <= 3.1

            Maybe due to e1855100e46040e73630b378974c17764e0cccee, CentOS, RHEL, and
            Fedora CIs have started failing with SEGV.  Try to avoid
            ffi_closure_alloc on those environments.

            https://rubyci.org/logs/rubyci.s3.amazonaws.com/centos8/ruby-master/log/20200512T183004Z.fail.html.gz
            https://rubyci.org/logs/rubyci.s3.amazonaws.com/fedora32/ruby-master/log/20200512T183004Z.fail.html.gz
            https://rubyci.org/logs/rubyci.s3.amazonaws.com/rhel8/ruby-master/log/20200512T183003Z.fail.html.gz

            ext/fiddle/extconf.rb: Fix the condition of libffi <= 3.1

            ver is [3, 1, 0] which is not less then or equal to [3, 1]

commit f46929833923d96e4dc706945fd537a1caaebe66
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-30 19:24:17 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-30 19:24:17 +0900

    merge revision(s) f96216df8dfd2d1e206150572912289f4dda7386,0091fac1d8de07e86fef8315ba77609bed9dd7f5,04c704c5c967ea9bded6bf645439fe59c7d9f7d6,23655e6de5ee989feb8c65c7061fe9a71579dc54,7cb8904a12c850ee30dcd67817fa2f9dc3fee813,41168f69fbeb32cfc88210911d62e419b8116589,87f6154bb4c67ca77ee353bb1fe25a922036c0e5: [Backport #17202]

            Remove "All Rights Reserved." from Copyright statement.

            Patch assembly so that it aligns properly

            Removed trailing spaces [ci skip]

            Fix build error on Apple silicon macOS

            This patch will fix following build error on macOS 11.0 + Xcode 12 beta.

            ```
            $ ./configure
            $ make V=1
                    BASERUBY = /Users/watson/.rbenv/shims/ruby --disable=gems
                    CC = clang -fdeclspec
                    LD = ld
                    LDSHARED = clang -fdeclspec -dynamiclib
                    CFLAGS = -O3 -ggdb3 -Wall -Wextra -Werror=deprecated-declarations -Werror=division-by-zero -Werror=implicit-function-declaration -Werror=implicit-int -Werror=misleading-indentation -Werror=pointer-arith -Werror=shorten-64-to-32 -Werror=write-strings -Wmissing-noreturn -Wno-constant-logical-operand -Wno-long-long -Wno-missing-field-initializers -Wno-overlength-strings -Wno-parentheses-equality -Wno-self-assign -Wno-tautological-compare -Wno-unused-parameter -Wno-unused-value -Wunused-variable -Werror=extra-tokens -std=gnu99  -pipe
                    XCFLAGS = -D_FORTIFY_SOURCE=2 -fstack-protector-strong -fno-strict-overflow -DRUBY_DEVEL=1 -fvisibility=hidden -DRUBY_EXPORT -fPIE -DCANONICALIZATION_FOR_MATHN -I. -I.ext/include/arm64-darwin20 -I./include -I. -I./enc/unicode/12.1.0
                    CPPFLAGS = -D_XOPEN_SOURCE -D_DARWIN_C_SOURCE -D_DARWIN_UNLIMITED_SELECT -D_REENTRANT
                    DLDFLAGS = -Wl,-undefined,dynamic_lookup -Wl,-multiply_defined,suppress -fstack-protector-strong -Wl,-pie -framework Security -framework Foundation
                    SOLIBS = -lpthread -ldl -lobjc
                    LANG = ja_JP.UTF-8
                    LC_ALL =
                    LC_CTYPE =
                    MFLAGS =
            Apple clang version 12.0.0 (clang-1200.0.22.19)
            Target: arm64-apple-darwin20.0.0
            Thread model: posix
            InstalledDir: /Applications/Xcode-beta.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/bin
            clang -fdeclspec -O3 -ggdb3 -Wall -Wextra -Werror=deprecated-declarations -Werror=division-by-zero -Werror=implicit-function-declaration -Werror=implicit-int -Werror=misleading-indentation -Werror=pointer-arith -Werror=shorten-64-to-32 -Werror=write-strings -Wmissing-noreturn -Wno-constant-logical-operand -Wno-long-long -Wno-missing-field-initializers -Wno-overlength-strings -Wno-parentheses-equality -Wno-self-assign -Wno-tautological-compare -Wno-unused-parameter -Wno-unused-value -Wunused-variable -Werror=extra-tokens -std=gnu99  -pipe  -D_FORTIFY_SOURCE=2 -fstack-protector-strong -fno-strict-overflow -DRUBY_DEVEL=1 -fvisibility=hidden -DRUBY_EXPORT -fPIE -DCANONICALIZATION_FOR_MATHN -I. -I.ext/include/arm64-darwin20 -I./include -I. -I./enc/unicode/12.1.0 -D_XOPEN_SOURCE -D_DARWIN_C_SOURCE -D_DARWIN_UNLIMITED_SELECT -D_REENTRANT    -o cont.o -c cont.c
            In file included from cont.c:19:
            ./coroutine/ucontext/Context.h:32:5: error: 'getcontext' is deprecated: first deprecated in macOS 10.6 [-Werror,-Wdeprecated-declarations]
                getcontext(&context->state);
                ^
            /Applications/Xcode-beta.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX.sdk/usr/include/ucontext.h:37:6: note: 'getcontext' has been
                  explicitly marked deprecated here
            int  getcontext(ucontext_t *) __OSX_AVAILABLE_BUT_DEPRECATED(__MAC_10_5, __MAC_10_6, __IPHONE_2_0, __IPHONE_2_0) __WATCHOS_PROHIBITED __TVOS_PROHIBITED;
                 ^
            In file included from cont.c:19:
            ./coroutine/ucontext/Context.h:51:5: error: 'makecontext' is deprecated: first deprecated in macOS 10.6 [-Werror,-Wdeprecated-declarations]
                makecontext(&context->state, (void(*)(void))coroutine_trampoline, 2, (void*)start, (void*)context);
                ^
            /Applications/Xcode-beta.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX.sdk/usr/include/ucontext.h:38:6: note: 'makecontext' has been
                  explicitly marked deprecated here
            void makecontext(ucontext_t *, void (*)(), int, ...) __OSX_AVAILABLE_BUT_DEPRECATED(__MAC_10_5, __MAC_10_6, __IPHONE_2_0, __IPHONE_2_0) __WATCHOS_PROHI...
                 ^
            In file included from cont.c:19:
            ./coroutine/ucontext/Context.h:59:5: error: 'swapcontext' is deprecated: first deprecated in macOS 10.6 [-Werror,-Wdeprecated-declarations]
                swapcontext(&current->state, &target->state);
                ^
            /Applications/Xcode-beta.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX.sdk/usr/include/ucontext.h:40:6: note: 'swapcontext' has been
                  explicitly marked deprecated here
            int  swapcontext(ucontext_t * __restrict, const ucontext_t * __restrict) __OSX_AVAILABLE_BUT_DEPRECATED(__MAC_10_5, __MAC_10_6, __IPHONE_2_0, __IPHONE_...
                 ^
            3 errors generated.
            make: *** [cont.o] Error 1
            ```

            Extract correct processor name for ARM64 Macs

            Prefix export symbol prefix to coroutine_transfer

            Revert "Revert "[ruby/fiddle] Use ffi_closure_free by default.
             (#20)""

            This reverts commit efd641ffab34e433a8d8a7d78914576f2425aa90.

            This changeset seems to be needed to suppress a warning on Ubuntu 20.04
            https://rubyci.org/logs/rubyci.s3.amazonaws.com/ubuntu/ruby-master/log/20200304T033004Z.log.html.gz
            ```
            closure.c:264:5: warning: 'ffi_prep_closure' is deprecated: use ffi_prep_closure_loc instead [-Wdeprecated-declarations]
              264 |     result = ffi_prep_closure(pcl, cif, callback, (void *)self);
                  |     ^~~~~~
            ```

            I guess there was a reason why the commit was reverted (maybe some CIs
            failed?), so try it again.

commit ea347990a5416c73a74f7dfa8a13b5ad5b7e79d4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-30 07:50:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-30 07:50:06 +0900

    merge revision(s) 07786edd66f59a529d6febb2e0fe901782991755,1917afa34bca55ba1ea578234132b7e4479ea3c9,0c611d7f4fce67c64bee4815f263c55ef15561c4:

            test/net/http/test_https.rb: Stop the error due to openssl 1.1.1h

            On some environments that uses OpenSSL 1.1.1h, the two tests now fail.

            http://rubyci.s3.amazonaws.com/android29-x86_64/ruby-master/log/20200924T062352Z.fail.html.gz
            https://github.com/ruby/ruby/runs/1159288773?check_suite_focus=true

            ```
              1) Failure:
            TestNetHTTPS#test_get [/data/data/com.termux/files/home/cb/tmp/build/20200924T062352Z/ruby/test/net/http/test_https.rb:47]:
            <"0\x82\x03\xED0\x82\x02\xD5\xA0\x03..."> expected but was
            <"0\x82\x03\xE30\x82\x02\xCB\xA0\x03...">.
            ```

            Not sure why, but verify_callback now seems to receive only SERVER_CERT
            but not CA_CERT.
            It would be good to investigate the issue furthermore, but tentatively,
            I want to stop the failures.

            test/net/http/test_https.rb: the order of verify_callback seems to
             vary

            ... depending upon the environment.

            test/net/http/test_https.rb: The test logic was buggy

            The expected certs must be `[CA_CERT, SERVER_CERT]` before 1.1.1g and
            `[SERVER_CERT]` after 1.1.1h.

commit 828c34e58b63d64558ec0f2d1d7ae401c5e6b21f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-29 22:46:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-29 22:46:14 +0900

    merge revision(s) d23d2f3f6fbb5d787b0dd80675c489a692be23e2:

            [ruby/webrick] Make it more strict to interpret some headers

            Some regexps were too tolerant.

            https://github.com/ruby/webrick/commit/8946bb38b4

commit df3f52a6331f1a47af9933b77311a8650727d8d1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-29 22:43:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-29 22:43:25 +0900

    merge revision(s) 996af2ce086249e904b2ce95ab2fcd1de7d757be: [Backport #16345] [Backport #17000]

            Disable deprecation warning by the default [Feature #16345]

            And `-w` option turns it on.

commit 665589cbdf7bf652067113dd1c0bc49012b990e0
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-29 20:33:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-29 20:33:06 +0900

    merge revision(s) df14c758fc705c49c2aaf4c9276a8f7229438fbf: [Backport #17181]

            Make hash returned by Hash#transform_values not have a default

            This sets an explicit default of nil.  There is probably a better
            approach of removing the default.

            Fixes [Bug #17181]

commit c10326d913a0340fc78ec94dc09d9e9398b31f1c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-20 20:23:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-20 20:23:51 +0900

    bump patchlevel to 128

commit 1b39a995b559677bf4bf2d0ac3a1c924928a936f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-20 20:23:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-20 20:23:12 +0900

    Revert "statement experssion is a GCCism" to pass ICC CI.

    This reverts commit a6b50f379d4b71acac73ac6b22cbe2d2c5b50b3f.

commit eb8270d67596fff58e245ff4227dd35e67dbef5c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-17 21:23:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-17 21:23:39 +0900

    Skip bundler spec using irb with simulated JRuby environment.

commit 0ebf6ea9a0d74f859ee4009fbe6693996f1fcdc7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-16 21:10:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-16 21:10:19 +0900

    bump patchlevel to 126

commit 21c1b676c4e9075549978918304206218478c459
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2020-09-16 11:36:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-16 21:09:17 +0900

    Merge latest readline-ext

commit 2159798f4c0f71007db733cddd82b99186c8e424
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2020-09-16 11:19:17 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-16 21:08:31 +0900

    Merge IRB 1.2.6

commit 3bb503e0e8f92c039ce50f430b14649a36c03feb
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2020-09-16 11:19:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-16 21:07:25 +0900

    Merge Reline 0.1.5

commit ed39078d37e16b541d717cd87cacb21aa33e6ef1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-15 20:56:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-15 20:56:13 +0900

    bump patchlevel to 125

commit 7d76314885be3532999684356657ce36da84d04e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2020-06-30 21:23:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-15 20:55:40 +0900

    Merge RubyGems 3.1.4

commit 3590f082442afc4506250f5274a7877371a112de
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2020-02-09 11:04:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-09 22:47:58 +0900

    spec/ruby/core/file/utime_spec.rb: far future timestamp may be trancated

    Under some Ext4 filesystem settings, a timestamp is limited up to
    0x37fffffff (2446-05-10).

    https://ext4.wiki.kernel.org/index.php/Ext4_Disk_Layout#Inode_Timestamps
    > Therefore, timestamps should not overflow until May 2446.

    Actually the spec fails under one of our CI environments, like:

    ```
    1)
    File.utime allows Time instances in the far future to set mtime and atime FAILED
    Expected 2446 == 559444
    to be truthy but was false
    ```
    https://rubyci.org/logs/rubyci.s3.amazonaws.com/arch/ruby-master/log/20200208T180002Z.fail.html.gz

commit 277076173af868d297070da43fcb3a06ccb7e21f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-07 21:13:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-07 21:13:43 +0900

    Run a TracePoint test in an insolated process

    to prevent a random failure like
    http://ci.rvm.jp/results/trunk-random2@phosphorus-docker/3024287

commit 2b5b9e12805597c3577b02b6c344d2b874220f3b
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2020-09-07 21:07:33 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2020-09-07 21:07:33 +0900

    * 2020-09-07 [ci skip]

commit a2f3aaea12ebaebf150a27268fc5f0f465e53b8f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-07 21:06:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-07 21:06:48 +0900

    Fix a random test failure by TracePoint

    A test worker process may already be enabling TracePoint, which results
    in changing the insn name in this test.

    http://ci.rvm.jp/results/trunk-random0@phosphorus-docker/3022750

commit dd4e51d84e01d9c60458dfe19a0b4d4e05b55140
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-06 11:16:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-06 11:16:29 +0900

    merge revision(s) ff5e66034006a875125581114cce19d46843b32a: [Backport #17015]

            Added `NODE_SPECIAL_EXCESSIVE_COMMA` info to `ARGS` of
             `RubyVM::AbstractSyntaxTree`.

commit 3fef159f81fad6ffb9af5b60f4c8ec867fdb2391
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-06 11:05:52 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-06 11:05:52 +0900

    merge revision(s) 3e02cd518fbe4d91c2aca7fbc3c5aafa387d3cb7: [Backport #17149]

            Trace :return of builtin methods

            using opt_invokebuiltin_delegate_leave insn.

            Since Ruby 2.7, :return of methods using builtin have not been traced properly.

commit e778de2c82478dda930cfc8d795ed4e0e60ea775
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-06 10:54:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-06 10:54:53 +0900

    merge revision(s) 11963da9e8e98821860fbb0c0f2adc118860c814: [Backport #16603] [Backport #17141]

            Check type of empty keyword [Bug #16603]

            Co-authored-by: Yusuke Endoh <mame@ruby-lang.org>

commit 9a1f0240cae95df4207bd95e7c0380d5307b7c9e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-05 19:19:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-05 19:19:20 +0900

    bump patchlevel to 119

commit 2c9dd060ab487a96e391793bd782cef6fd471b83
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-09-05 19:18:07 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-09-05 19:18:07 +0900

    Revert "Don't display singleton class in Method#inspect unless method defined there"
    [Backport #16771]

    This reverts commit 0d24fb774d84d4a99454ce10fd343da00049a588.

commit e9e4f8430a62f56a4e62dd728f4498ee4c300c12
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-08-07 20:16:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-08-07 20:16:51 +0900

    merge revision(s) 8e189df32cacef4b21e357a590d349330532baf5: [Backport #17013]

            Add operator info to `OP_ASGN2` of `RubyVM::AbstractSyntaxTree`.

commit 23d130a9ddcaf766d6ce309f8518b434a2537fc1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-08-01 17:33:56 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-08-01 17:33:56 +0900

    merge revision(s) d05f04d27dd86c67e4a8dfff4392f806cf577bdf: [Backport #16931]

            Fixed `defined?` against protected method call

            Protected methods are restricted to be called according to the
            class/module in where it is defined, not the actual receiver's
            class.  [Bug #16931]

commit 315f1ee8a80680fd7aff5fa27abfd965d1906809
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-06-02 17:07:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-08-01 17:17:01 +0900

    Split test_defined_method

commit 171d4c512b1497178b39db32b255eb521560d78c
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2020-05-08 06:05:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-08-01 17:17:00 +0900

    Fix typo in test name

commit b222ae41015646e238e1d2f6710da02f38578388
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-04-23 09:43:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-08-01 17:17:00 +0900

    Test for [Bug #16669]

commit 34427bc09e68a81a9986bc7fe0d1d9886e6d00d5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-04-22 22:21:11 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-08-01 17:17:00 +0900

    Split test_defined

commit a024bae53999cb02f6ef556bbe03af8b6d002bcf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-08-01 16:56:42 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-08-01 16:56:42 +0900

    bump up patchlevel for a332e8a0ddad90c540c6c52f0db2a45e5955a23d

commit a332e8a0ddad90c540c6c52f0db2a45e5955a23d
  Author:     MSP-Greg <Greg.mpls@gmail.com>
  AuthorDate: 2020-07-26 22:57:59 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-08-01 16:55:54 +0900

    ruby_2_7 update MinGW Actions workflow

commit 05c4c88767b54808cd1459a1d6da11179c422cfa
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-26 18:32:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-26 18:32:36 +0900

    merge revision(s) 1b4d406e3a04032b6d01e92b6d184a16945c6ac3: [Backport #16498] [Backport #16914]

            Hash#transform_values should return a plain new Hash

            [Bug #16498]

commit 61c6d433060881e952140d2154c06f8c9803dc8a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-26 17:45:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-26 17:45:31 +0900

    partially merge revision adf709a78534c1483ba851ccb0490464ca31503c: [Backport #16801]

            Classes made from Struct should have default new singleton method.

            Co-authored-by: Yusuke Endoh mame@ruby-lang.org
            Co-authored-by: John Hawthorn john@hawthorn.email
            Co-authored-by: Adam Hess HParker@github.com
            Co-authored-by: Jose Cortinas jacortinas@gmail.com
            Co-authored-by: Jean Boussier jean.boussier@gmail.com

commit 43cc6997c59d2fbe3b91e91ee52faaa8749e9349
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-26 16:19:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-26 16:19:40 +0900

    merge revision(s) a0bc3f2a1c2c98f225612101cb4e1ea1a6813546,75a0447c15a7ab017bd4240c2a9cc69b134b80b9,f1699314147bad2cf5550cc582693424fdbc2510: [Backport #16846]

            Suppress C4267 "possible loss of data" warnings

            Suppress C4267 "possible loss of data" warnings

            Just cast down explicitly.

            win32ole: separate global variable declarations and definitions

            https://gcc.gnu.org/gcc-10/changes.html#c

            > * GCC now defaults to `-fno-common`.  As a result, global
            >   variable accesses are more efficient on various targets.  In
            >   C, global variables with multiple tentative definitions now
            >   result in linker errors.  With `-fcommon` such definitions are
            >   silently merged during linking.

commit 578bacc471fa3fa14f8607fe67adccce21e81657
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-25 21:42:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-25 21:42:20 +0900

    merge revision(s) 5e81e8675a020ecd493620a4ff38db8fcf4b972a: [Backport #16780]

            Ignore exceptions when closing data connections [Bug #16780]

            Patch by koshigoe (Masataka SUZUKI). Thanks!

commit 12391cdbe11f3fbeb3b04c30b944139e5bbd9ea6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-25 14:17:35 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-25 14:17:35 +0900

    merge revision(s) cbe4f75ef802f13d05f94e42274b65a062bd3666: [Backport #16834]

            Fix rb_profile_frame_classpath to handle module singletons

            Right now `SomeClass.method` is properly named, but `SomeModule.method`
            is displayed as `#<Module:0x000055eb5d95adc8>.method` which makes
            profiling annoying.

commit be359442cb07c25fdc769431ffed3249b9016829
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-25 13:40:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-25 13:40:48 +0900

    merge revision(s) 71c166e11e761dcaaa943f9b94da38f86ada1bdb: [Backport #16854]

            Fixed argument forwarding in reserved word method [Bug #16854]

commit 89f06ce8b8a887f12b53ea190d79a58e98b59008
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-25 12:00:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-25 12:00:39 +0900

    merge revision(s) 08529a61153e5c40f57a65272211357511d6e6db: [Backport #16798]

            Compare environment variable names in those manor [Bug #16798]

commit 2e9626fddd168bd12352b4f5dc3412c6a33ce44e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-25 11:56:28 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-25 11:56:28 +0900

    merge revision(s) 2f1895fa15386fb3cdc91c5604171290828b9da8: [Backport #16767]

            Fixed formatted substring expansion [Bug #16767]

commit c65aae118ccff86096b9983641b371491bc23434
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-23 17:47:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-23 17:47:12 +0900

    merge revision(s) 927308108cced69cae478798004524b9a5d2f252: [Backport #16764]

            Fix source location of autoloaded constant [Bug #16764]

commit 4437f9eb0bf8369bcf12bd7cd324e11b5d885e07
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-23 17:30:26 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-23 17:30:26 +0900

    merge revision(s) da05c1552ee519d8f180b48d97148d28501acb35: [Backport #16749]

            Update to ruby/spec@cc7b9e5

commit c53cee7a0e7b3e87ba3fbafa86bd74460af18d93
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-23 17:22:45 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-23 17:22:45 +0900

    merge revision(s) 72c02aa4b79731c7f25c9267f74b347f1946c704: [Backport #16662]

            Moved not-implemented method tests [Bug #16662]

            Test not-implemented method with the dedicated methods, instead of
            platform dependent features.

commit ae804b143455075687c8b4a401fba48fda72a217
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-23 16:59:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-23 16:59:03 +0900

    merge revision(s) b23fd59cbb3f097bcd559d0c85a86ff7a1eeeb7e: [Backport #16501]

            marshal.c: Support dump and load of a Hash with the ruby2_keywords
             flag

            It is useful for a program that dumps and load arguments (like drb).
            In future, they should deal with both positional arguments and keyword
            ones explicitly, but until ruby2_keywords is deprecated, it is good to
            support the flag in marshal.

            The implementation is similar to String's encoding; it is dumped as a
            hidden instance variable.

            [Feature #16501]

commit f1563edca0af1a5ad5cc748eb855ff9265e69e7f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-01-11 16:32:56 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-23 16:56:42 +0900

    Get rid of use of magic number 'E'

commit 4f714939efde6d6b3b74c09e1e151e6ce6818b90
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-23 14:02:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-23 14:02:05 +0900

    merge revision(s) e04418bb16cd99b4a4402e7457d3bdc967284f98: [Backport #16830]

            [ruby/uri] Check if DN exists

            https://bugs.ruby-lang.org/issues/16830

            https://github.com/ruby/uri/commit/b4bf8c1217

commit 9da6470d7b3aa136b4b92469c8bbc522beb1ac31
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-23 13:50:56 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-23 13:50:56 +0900

    merge revision(s) a2be428c5fec31b8adbd5ac087e7637ddf7e54d0: [Backport #16826]

            Fix ObjectSpace::WeakMap#key? to work if the value is nil

            * Fixes [Bug #16826]

commit 27fa1c61b78c1685ccf9ac203a95cfa9041d618f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-23 12:13:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-23 12:13:30 +0900

    merge revision(s) 579645d9f870fa4116dcd3200bbbb6e2c0b7f400: [Backport #17033]

            Fixed infinite loop at error in printing cause [Bug #17033]

commit 4be9bf1f67b997fc519625d56a93b8a68a70d124
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-23 11:33:11 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-23 11:33:11 +0900

    merge revision(s) 99a9c3fe2eaab8157765d792dc871da6daea0327: [Backport #17024]

            Fixed yday and wday with timezone [Bug #17024]

commit 13d2ab0d88bbf72ed310efaec6edc46dd96fdb4d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-23 11:16:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-23 11:16:31 +0900

    merge revision(s) 2ecfb88ee50510955acd3ae9fc94a5f109e7f109: [Backport #16918]

            Correctly remove temporary directory if path yielded is mutated

            Another approach would be to freeze the string, but that could
            cause backwards compatibility issues.

            Fixes [Bug #16918]

commit cc39480cf9f2767967b6bcc69ccb3c201e5b2231
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-23 11:11:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-23 11:11:12 +0900

    merge revision(s) 5a79d8e0507cd143100bf928a88a59a8b5a5bca6,160511d851375f7cb922faae3a9310633187f51f: [Backport #16925]

            Fix error raised by Net::HTTPResponse#inflater if the block raises

            * See https://bugs.ruby-lang.org/issues/13882#note-6

            Quarantine specs which fail frequently with CHECK_LEAKS=true

commit d24cce8e7f48b0b45f726f5f1ac7ff796f46ba72
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-19 12:16:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-19 12:16:37 +0900

    merge revision(s) bf1a6771f305ea286a3ae575676924551c03e857,c1463625555b061a2b94c3b6c5581730b482a285: [Backport #17012] [Backport #17014]

            Fix non-numeric exclusive Range#minmax bug

            The implementation of Range#minmax added in d5c60214c45 causes the
            following incorrect behaviour:

              ('a'...'c').minmax => ["a", ["a", "b"]]

            instead of

              ('a'...'c').minmax => ["a", "b"]

            This is because the C implementation of Range#minmax (range_minmax)
            directly delegates to the C implementation of Range#min (range_min) and
            Range#max (range_max), without changing the execution context.

            Range#max's C implementation (range_max), when given a non-numeric
            exclusive range, delegates to super, which is meant to call
            Enumerable#max. However, because range_max is called directly by
            range_minmax, super calls Enumerable#minmax instead, causing the
            incorrect nesting.

            Perhaps it is possible to change the execution context in an optimized
            manner, but the simplest solution seems to be to just explicitly
            delegate from Range#minmax to Range#min and Range#max.

            Use static variables in Range#minmax

commit f43b8c4f7304ebea91cd01d5606e13273d0fd755
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-19 11:56:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-19 11:56:32 +0900

    merge revision(s) 0ba27259d390e902139c0e2e94b9d18ef227748e: [Backport #16940]

            Fix crashes in the peephole optimizer on OpenBSD/sparc64

            These crashes are due to alignment issues, casting ADJUST to INSN
            and then accessing after the end of the ADJUST.  These patches
            come from Stefan Sperling <stsp@apache.org>, who reported the
            issue.

commit e619178e52250ceda3a0fe32ff5addb16617b58c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-19 11:52:11 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-19 11:52:11 +0900

    merge revision(s) 6e7e7c1e577d6c2276e9a8cc85c28c55c46c2618: [Backport #17023]

            Only marked objects should be considered movable

            Ruby's GC is incremental, meaning that during the mark phase (and also
            the sweep phase) programs are allowed to run.  This means that programs
            can allocate objects before the mark or sweep phase have actually
            completed.  Those objects may not have had a chance to be marked, so we
            can't know if they are movable or not. Something that references the
            newly created object might have called the pinning function during the
            mark phase, but since the mark phase hasn't run we can't know if there
            is a "pinning" relationship.

            To be conservative, we must only allow objects that are not pinned but
            also marked to move.

commit ad15fd03e915272bdf4b3a8403722b397e3afcf8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-19 11:32:59 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-19 11:32:59 +0900

    merge revision(s) 26c179d7e7e7ae0eb21050659c3e8778358230ab: [Backport #17026]

            Check argument to ObjectSpace._id2ref

            Ensure that the argument is an Integer or implicitly convert to,
            before dereferencing as a Bignum.  Addressed a regression in
            b99833baec2.

            Reported by u75615 at https://hackerone.com/reports/898614

commit 9e76124a2b11003f1000bd330a0121f1914af290
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-18 13:24:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-18 13:35:45 +0900

    bump patchlevel to 93

commit 17b088d1e5d0378d9752f807e607adde0cb47ef1
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2020-03-12 15:30:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-18 13:35:45 +0900

    Update some syslog tests to absurb the format change of FreeBSD syslog

    FreeBSD

    ```
    $ ruby -rsyslog -e 'Syslog.open("rubyspec", Syslog::LOG_PERROR) {|s| s.log(Syslog::LOG_ALERT, "Hello") }'
    rubyspec 78462 - - Hello
    ```

    Linux

    ```
    $ ruby -rsyslog -e 'Syslog.open("rubyspec", Syslog::LOG_PERROR) {|s| s.log(Syslog::LOG_ALERT, "Hello") }'
    rubyspec: Hello
    ```

    https://github.com/freebsd/freebsd/commit/591ef7c8076109cff3c41f9bb50da996a34121e9

commit 0c4d93e6991d365cc77fbaaeae367b9651f2d4cd
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2020-02-17 17:14:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-18 13:17:10 +0900

    test/openssl/test_ssl: skip test_fallback_scsv if necessary

    Run the test case only when the OpenSSL supports both TLS 1.1 and TLS
    1.2. Note that the fallback SCSV mechanism is for TLS 1.2 or older and
    not for 1.3.

    Fixes: https://github.com/ruby/openssl/issues/336

commit bad7ab35d1e38f47b09f15fc5750387ac73b2286
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2020-05-12 17:47:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-11 16:23:59 +0900

    test/lib/jit_support.rb: Let JIT tests skip on centos8

    It has the same issue as RHEL 8.  k0kubun said he will fix later

commit b4c893a62c71ac28795f8fcefb375131833afd0c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-11 16:10:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-11 16:10:41 +0900

    OpenSSL 1.1.1 introduces a new '.include' directive. Update our config
    parser to support that.

    As mentioned in the referenced GitHub issue, we should use the OpenSSL
    API instead of implementing the parsing logic ourselves, but it will
    need backwards-incompatible changes which we can't backport to stable
    versions. So continue to use the Ruby implementation for now.

    References:
      https://github.com/ruby/openssl/issues/208
      https://github.com/ruby/openssl/pull/216

    The original patch was written by Kazuki Yamaguchi <k@rhe.jp> and
    the patch for ruby_2_7 branch was prepared by Vít Ondruch.

commit a0bb4eb04512b3f8ca50ec5fa72e3d4a8278ca46
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-10 08:51:53 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-10 08:51:53 +0900

    bump patchlevel: merge commits: 5c2508060b79b4299a18d05511d3530ad14b1b7a 2480ef904c66812cf366e5d9bc8a9c3c20bbf271 47720e2255f34ecad49763c66a7ea02a55a3f60a

commit b971bad49b95d4c1f68bb2242d4267355f1cd497
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-05-04 13:35:38 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-10 08:50:41 +0900

    Bison 3.59.1 folds yydestruct function header

commit 06ab2791c38c431e08bc8d9381c9a1ca727297c4
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-05-20 10:52:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-10 08:50:41 +0900

    pure_parser.rb: get rid of an error at localed messages

commit 1ee1684a4a3edb26b5aa32acc967b9ef26284d42
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-05-04 18:10:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-10 08:50:41 +0900

    Bison 3.5.91 now defaults parse.error to "simple"

commit 601613fdf3907f3842a9d465926dca7c37d56f72
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-09 21:03:58 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-09 21:03:58 +0900

    merge revision(s) 87ad5ea729735ff6b8f1ac0bb3aad2aedd6f716e,9745e90197f129708986803e8913fb151862478a:

            Skip jit_test on some new RubyCI envs for now

            Propagate JIT skip to all tests

commit 6c22070408f9729621712190bfc8460e5eebcb03
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-09 20:54:28 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-09 20:54:28 +0900

    merge revision(s) 21d8e6924844d592ff2d5a2e7309457eb92e66f6:

            disable to show the maximum number of threads.

            On Deiban 9 environment, the thread tests failed and
            this maximum threads information can finish up the machine
            resources. To check it, I turned-off showing this information.

commit 9720591043003a5262c8f3e1c1720771bc77488b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-07-05 07:03:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-07-05 07:03:14 +0900

    merge revision(s) 75802bcff1b941818832f0145071f7ce9c843d8d:

            configure: suppress icc warnings

            Every time a pointer to/from VALUE conversion happens, these two
            warnings are issued:

            - warning #1684: conversion from pointer to same-sized integral type (potential portability problem)
            - warning #2312: pointer cast involving 64-bit pointed-to type

            Thank you, but we are well aware of the "potential portability problem".
            Let us ignore them all.

commit 799c5766a4dc215d139d2c26ac68636f43a64fbf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-06-27 12:29:42 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-06-27 12:29:42 +0900

    merge revision(s) a19228f878d955eaf2cce086bcf53f46fdf894b9: [Backport #16979]

            brace the fact that lchmod(2) can EOPNOTSUPP

            Musl libc has this function as a tiny wrapper of fchmodat(3posix).  On
            the other hand Linux kernel does not support changing modes of a symlink.
            The operation always fails with EOPNOTSUPP.  This fchmodat behaviour is
            defined in POSIX.  We have to take care of such exceptions.

commit d8a32b146561a0ddd3e60da9863a082b7e7725db
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-06-27 12:20:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-06-27 12:20:36 +0900

    merge revision(s) 263b941321c3de6afc8f9dafbc2625f866b7437e: [Backport #16981]

            [ripper] fix mismatched indentations warning [Bug #16981]

            The scanner location has to be set from `lex.ptok` before it is
            flushed by dispatching the scanner event.

commit 3c55d93cf68b1a969b90b306de4dd8b88d74a2f2
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-06-13 11:29:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-06-13 11:29:51 +0900

    merge revision(s) 7e289cdf3fed588b2d5a6973e29f9ff95cb8d76c: [Backport #16949]

            [ruby/psych] Fixing compatibility with libyaml 0.2.5

            The main issue is that commas aren't allowed in local tags.  libyaml
            was updated to follow the spec, and our tests were out of date.

            See: https://github.com/yaml/libyaml/issues/196

            https://github.com/ruby/psych/commit/3f5e520fd3

commit 241cb3fa0316b3846f7b137921301f7279a03161
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2020-06-08 09:58:19 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2020-06-08 09:58:19 +0900

    * 2020-06-08 [ci skip]

commit 16aef5da5622971ae83dcc281b03a53c5f622ca3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2020-06-07 12:04:23 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2020-06-07 12:04:23 +0900

    merge revision(s) ac2106acc276854ae2ac8cc5fa6859aa28362f2f,cf90df22c74da2f87421749e8d065cfbd3812afd: [Backport #16813]

            [DOC] Fixed explanation for Method#>> [Bug #16813] [ci skip]

            [DOC] Separated Method#[] from Method#call [Bug #16813] [ci skip]

commit a0c7c23c9cec0d0ffcba012279cd652d28ad5bf3
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2020-03-31 19:27:41 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-31 19:44:55 +0900

    v2.7.1p83

commit f832d957b837d5167058a3f8579d66e5b5d3472e
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2020-03-31 19:26:10 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-31 19:26:10 +0900

    ext/socket/init.c: do not return uninitialized buffer

    BasicSocket#read_nonblock and some methods changes the size of a buffer
    string, but when no data is available, the buffer is returned as
    uninitialized.

    Co-Authored-By: Samuel Williams <samuel.williams@oriontransfer.co.nz>

commit 5caee29164de6477b5cad1328b56e696a41d5025
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2020-03-31 16:31:53 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2020-03-31 16:31:53 +0900

    * 2020-03-31 [ci skip]

commit bb93659fefd7f4557129043742771a33bd30c255
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2020-03-31 16:10:57 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2020-03-31 16:10:57 +0900

    Fix pp when passed a empty ruby2_keywords-flagged hash as array element (#2966)

    This causes problems because the hash is passed to a block not
    accepting keywords.  Because the hash is empty and keyword flagged,
    it is removed before calling the block.  This doesn't cause an
    ArgumentError because it is a block and not a lambda.  Just like
    any other block not passed required arguments, arguments not
    passed are set to nil.

    Issues like this are a strong reason not to have ruby2_keywords
    by default.

    Fixes [Bug #16519]

    This backports 28d31ead34baff1c4abc0d7d902ef4bc1d576fb2 and
    0ea759eac9234afc47e8fb1bcacfe9ee12c8ffb6, but needed to be modified
    for 2.7 as 2.7 will perform empty keyword to positional hash
    conversion for required arguments, which will happen if "v" in the
    seplist method is empty when yielded.

    Co-authored-by: NARUSE, Yui <nurse@users.noreply.github.com>

commit d04856bdc502eec4055da1e5cf717639c314e189
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2020-03-30 19:15:42 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2020-03-30 19:15:42 +0900

    * 2020-03-30 [ci skip]

commit b5fa156b7907b8ea1baf8b9f0cb6a66b0fecb3d4
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2020-03-11 23:37:14 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-30 19:15:11 +0900

    Clear all trace events during teardown

    Since 0c2d81dada, not all trace events are cleared during VM teardown.
    This causes a crash when there is a tracepoint for
    `RUBY_INTERNAL_EVENT_GC_EXIT` active during teardown.

    The commit looks like a refactoring commit so I think this change was
    unintentional.

    [Bug #16682]

    (cherry picked from commit b385f7670ffa420790bc548747fa4b58c4c5d8f6)

commit 0057fe4063b57b445d6ffc893e442f362e3a19e0
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2020-03-30 19:09:50 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2020-03-30 19:09:50 +0900

    Ruby 2.7 backport about IRB (#2990)

    * [ruby/reline] Sort completion list

    #### Legacy mode:

      ```console
      $ irb --legacy
      irb(main):001:0> l[TAB][TAB]
      lambda           load             local_variables  loop
      ```

    #### Before this patch:

      ```console
      $ irb
      irb(main):001:0> l[TAB][TAB]
      local_variables
      loop
      lambda
      load
      ```

    #### After this patch:

      ```console
      $ irb
      irb(main):001:0> l[TAB][TAB]
      lambda
      load
      local_variables
      loop
      ```

    https://github.com/ruby/reline/commit/6074069c7d

    * Drop an invalid char as UTF-8

    * Add test_completion_with_indent_and_completer_quote_characters

    This is for 8a705245e55575d4d310a2e956b89a36a5931971.

    * [ruby/irb] Add tests for RubyLex

    The set_auto_indent method calculates the correct number of spaces for
    indenting a line. We think there might be a few bugs in this method so
    we are testing the current functionality to make sure nothing breaks
    when we address those bugs.

    Example test failure:

    ```
      1) Failure:
    TestIRB::TestRubyLex#test_auto_indent [/Users/Ben/Projects/irb/test/irb/test_ruby_lex.rb:75]:
    Calculated the wrong number of spaces for:
     def each_top_level_statement
      initialize_input
      catch(:TERM_INPUT) do
        loop do
          begin
            prompt
            unless l = lex
              throw :TERM_INPUT if @line == ''
            else
    .
    <10> expected but was
    <12>.
    ```

    https://github.com/ruby/irb/commit/752d5597ab

    * [ruby/reline] Degenerate the terminal size to [$LINES, $COLUMNS] if it is unknown

    This is a workaround for https://github.com/ruby/irb/issues/50

    https://github.com/ruby/reline/commit/5725677d1a

    * [ruby/irb] Fix newline depth with multiple braces

    This commit fixes the check_newline_depth_difference method to multiple
    open braces on one line into account. Before this change we were
    subtracting from the depth in check_newline_depth_difference on
    every open brace. This is the right thing to do if the opening and
    closing brace are on the same line. For example in a method definition we
    have an opening and closing parentheses we want to add 1 to our depth,
    and then remove it.

    ```
    def foo()
    end
    ```

    However this isn't the correct behavior when the brace spans multiple
    lines. If a brace spans multiple lines we don't want to subtract from
    check_newline_depth_difference and we want to treat the braces the same
    way as we do `end` and allow check_corresponding_token_depth to pop the
    correct depth.

    Example of bad behavior:

    ```
    def foo()
      [
      ]
    puts 'bar'
    end
    ```

    Example of desired behavior:

    ```
    def foo()
      [
      ]
      puts 'bar'
    end
    ```

    https://github.com/ruby/irb/commit/7dc8af01e0

    * text/readline/test_readline.rb - fix skip on Reline (#2743)

    TestRelineAsReadline#test_input_metachar passes on MinGW

    * Add "require 'openstruct'" what is forgotten

    * [ruby/irb] Fix lib name of OpenStruct

    https://github.com/ruby/irb/commit/1f3a84ab6b

    * Add load path and require for ruby/ruby

    * Rescue EOFError

    If C-d is pressed before IRB is ready, IRB crashes because EOFError occurs.

    * Complete indented and quoted string correctly

      def foo
        ''.upca[TAB]

    This will be completed to be:

      def foo
      ''.upcase

    The indent was gone. This commit fixes the bug.

    * [ruby/irb] Fix crashing when multiple open braces per line

    https://github.com/ruby/irb/issues/55

    If we had put multiple open braces on a line the with no closing brace
    spaces_of_nest array keeps getting '0' added to it. This means that when
    we pop off of this array we are saying that we should be in position zero
    for the next line. This is an issue because we don't always want to be
    in position 0 after a closing brace.

    Example:
    ```
    [[[
    ]
    ]
    ]
    ```
    In the above example the 'spaces_of_nest' array looks like this after
    the first line is entered: [0,0,0]. We really want to be indented 4
    spaces for the 1st closing brace 2 for the 2nd and 0 for the 3rd. i.e.
    we want it to be: [0,2,4].

    We also saw this issue with a heredoc inside of an array.

    ```
    [<<FOO]
    hello
    FOO
    ```

    https://github.com/ruby/irb/commit/80c69c8272

    * Support history-size in .inputrc correctly

    * Introduce an abstracted structure about the encoding of Reline

    The command prompt on Windows always uses Unicode to take input and print
    output but most Reline implementation depends on Encoding.default_external.
    This commit introduces an abstracted structure about the encoding of Reline.

    * Remove an unused setting variable

    * Use Reline.encoding_system_needs if exists

    * Add tests for vi_insert and vi_add

    * Implement vi_insert_at_bol and vi_add_at_eol

    * [ruby/reline] Implement vi_to_next_char

    https://github.com/ruby/reline/commit/066ecb0a21

    * [ruby/reline] Implement vi_prev_char and vi_to_prev_char

    https://github.com/ruby/reline/commit/0ad3ee63fa

    * [ruby/readline-ext] Include ruby/assert.h in ruby/ruby.h so that assertions can be there

    https://github.com/ruby/readline-ext/commit/4d44c12832

    * Stop using minitest dependent methods

    * Skip a test that uses assert_ruby_status if it doesn't exist

    * Use omit instead of skip

    * Check DONT_RUN_RELINE_TEST envvar

    * [ruby/irb] Add newline_before_multiline_output

    https://github.com/ruby/irb/commit/9eb1801a66

    * [ruby/irb] Fix compatibility with rails before 5.2

    Rails before 5.2 added Array#append as an alias to Array#<< ,
    so that it expects only one argument.
    However ruby-2.5 added Array#append as an alias to Array#push
    which takes any number of arguments.

    If irb completion is used in `rails c` (for example "IO.<tab>")
    it fails with:
      irb/completion.rb:206:in `<<': wrong number of arguments (given 3, expected 1) (ArgumentError)

    Using Array#push instead of Array#append fixes compatibility.

    https://github.com/ruby/irb/commit/5b7bbf9c34

    * Reline: Use a more robust detection of MinTTY

    The previous detection per get_screen_size fails when stdout is passed
    to a pipe. That is the case when running ruby tests in parallel ("-j" switch).
    In this case Reline believes that it's running on MinTTY and the tests
    are running with ANSI IOGate instead of the Windows adapter on MINGW.
    So parallel test results were different to that of a single process.
    This commit fixes these differencies.

    The code is taken from git sources and translated to ruby.
    NtQueryObject() is replaced by GetFileInformationByHandleEx(), because
    NtQueryObject() is undocumented and is more difficult to use:
      https://github.com/git-for-windows/git/blob/c5a03b1e29c69f3f06c8fabd92493edb73469176/compat/winansi.c#L558

    * Reline: Fix changed test results due to change to UTF-8 on Windows

    In commit f8ea2860b0cac1aec79978e6c44168802958e8af the Reline encoding
    for native windows console was changed to hardcoded UTF-8.
    This caused failures in reline and readline tests, but they were hidden,
    because parallel ruby tests incorrectly used Reline::ANSI as IOGate.
    Tests failures were raised in single process mode, but not with -j switch.

    This patch corrects encodings on native Windows console.

    * [ruby/irb] [ruby/irb] Rewrite an expression to detect multiline

    https://github.com/ruby/irb/commit/ed5cf375a6

    https://github.com/ruby/irb/commit/5b7bbf9c34

    * [ruby/reline] Implement vi_change_meta

    https://github.com/ruby/reline/commit/8538e0e10f

    * Always refer to Reline::IOGate.encoding

    * Always use UTF-8 for Reline::GeneralIO on Windows

    * Use test_mode on Reline::History::Test for encoding

    * [ruby/reline] Support GNOME style Home/End key sequences [Bug #16510]

    https://github.com/ruby/reline/commit/788f0df845

    * [ruby/irb] Add a new easter egg: dancing ruby

    https://github.com/ruby/irb/commit/e37dc7e58e

    * [ruby/irb] Exclude useless files from RDoc

    https://github.com/ruby/irb/commit/8f1ab2400c

    * [ruby/irb] Exclude useless files from RDoc

    * Fix inaccuracy in encoding tests

    These tests assume
      Encoding.find('locale') == Encoding.find('external')
    and fail if they are distinct.

    * [ruby/reline] Fix Reline::Windows#scroll_down

    I mistook Right and Bottom.

    https://github.com/ruby/reline/commit/8be401c5f5

    * [ruby/reline] Bypass cursor down when a char is rendered at eol on Windows

    A newline is automatically inserted if a character is rendered at eol on
    Windows command prompt.

    https://github.com/ruby/reline/commit/4bfea07e4a

    * [ruby/reline] Organize special keys escape sequences

    https://github.com/ruby/reline/commit/41deb1a3d9

    * [ruby/readline-ext] Remove unnecessary -I$(top_srcdir) when it's an individual gem

    https://github.com/ruby/readline-ext/commit/efaca4a5f4

    * [ruby/readline-ext] Check TestRelineAsReadline existance

    https://github.com/ruby/readline-ext/commit/c0a6303168

    * [ruby/readline-ext] The ruby/assert.h is adopted by Ruby 2.7 or later

    https://github.com/ruby/readline-ext/commit/106c31fc1b

    * Revert "[ruby/readline-ext] Include ruby/assert.h in ruby/ruby.h so that assertions can be there"

    This reverts commit 425b2064d394639101854c83a061a0918b33b857.

    This cherry-pick was a mistake.

    * [ruby/readline-ext] Use require check instead of DONT_RUN_RELINE_TEST env

    https://github.com/ruby/readline-ext/commit/1df99d1481

    * [ruby/readline-ext] Add spec.extensions

    https://github.com/ruby/readline-ext/commit/8c33abb13c

    * [ruby/readline-ext] Use rake/extensiokntask to build

    https://github.com/ruby/readline-ext/commit/b0b5f709bd

    * Fix readline build dependency

    * [ruby/irb] Add test_complete_symbol

    https://github.com/ruby/irb/commit/dbbf086c1f

    * [ruby/irb] Check doc namespace correctly

    IRB::InputCompletor::PerfectMatchedProc crashes when doc not found because a
    variable name was incorrect.

    https://github.com/ruby/irb/commit/889fd4928f

    * [ruby/irb] Fix auto indent with closed brace

    A closed brace in auto-indent shouldn't affect the next brace in the same line,
    but it behaves like below:

      p() {
        }

    It's a bug.

    https://github.com/ruby/irb/commit/fbe59e344f

    * [ruby/irb] Use 0.step instead of (..0).each for Ruby 2.5

    https://github.com/ruby/irb/commit/5d628ca40e

    * Revert "[ruby/irb] Add test_complete_symbol"

    This reverts commit 3af3431c2c145134996e66f3d8d9ade8ad81bde0.

    * [ruby/irb] fix reserved words and completion for them

    https://github.com/ruby/irb/commit/6184b227ad

    * Add test_complete_symbol

    The previous version of the test method used a symbol, ":abcdefg" to complete
    but longer symbols that can be completed are defined by other test methods of
    other libs.

    * test/irb/test_completion.rb: suppress a warning: unused literal ignored

    * [ruby/reline] Use IO#write instead of IO#print

    IO#print always adds a string of $\ automatically.

    https://github.com/ruby/reline/commit/a93119c847

    * [ruby/irb] Version 1.2.2

    https://github.com/ruby/irb/commit/a71753f15a

    * [ruby/reline] Version 0.1.3

    https://github.com/ruby/reline/commit/ea2b182466

    * [ruby/irb] Include easter-egg.rb in gemspec

    `irb` doesn't run because this file isn't included in the gem.
    https://github.com/ruby/irb/commit/73cda56d25

    * [ruby/irb] Version 1.2.3

    https://github.com/ruby/irb/commit/dd56e06df5

    * support multi-run test for test_readline.rb

    * [ruby/irb] `yield` outside method definition is a syntax error

    https://github.com/ruby/irb/commit/dbc7b059c7

    * test/readline - allow ENV control of test class creation

    In ruby/ruby, the tests run on both readline & reline by creating four test classes:
    ```
    TestReadline
    TestReadlineHistory

    TestRelineAsReadline
    TestRelineAsReadlineHistory
    ```

    Reline inports the test files and uses them in its CI.  Adding the ENV control allows it to only run the `TestRelineAsReadline` classes.

    * Omit test_using_quoting_detection_proc_with_multibyte_input temporarily for random order test

    * support random order test.

    test_readline:
      HISTORY should be empty.

    test_using_quoting_detection_proc:
    test_using_quoting_detection_proc_with_multibyte_input:
      Readline.completer_quote_characters= and
      Readline.completer_word_break_characters= doesn't accept nil,
      so skip if previous values are nil.

    * Set Readline.completion_append_character = nil always

    GNU Readline add a white space when Readline.completion_append_character is
    not initialized.

    * Fix a typo [ci skip]

    * skip test if Reline.completion_proc is nil.

    Some other tests can set Reline.completion_proc, so if it is nil,
    simply skip this test.

    * Reset Reline.point

    TestRelineAsReadline#test_insert_text expects Readline.point == 0
    at the beginning of the test, but a test violate this assumption.

    * Convert incompatible encoding symbol names

    * Ignore incompatible convert of symbols

    * Add workaround for test-bundler failure

    https://github.com/ruby/actions/runs/500526558?check_suite_focus=true#step:16:127
    ```
    Failures:

      1) Bundler.setup when Bundler is bundled doesn't blow up
         Failure/Error: expect(err).to be_empty

           expected `"fatal: not a git repository (or any of the parent directories): .git\nfatal: not a git repository (o...the parent directories): .git\nfatal: not a git repository (or any of the parent directories): .git".empty?` to return true, got false

           Commands:
           $ /home/runner/work/actions/actions/snapshot-master/ruby \
             -I/home/runner/work/actions/actions/snapshot-master/lib:/home/runner/work/actions/actions/snapshot-master/spec/bundler \
             -rsupport/hax -rsupport/artifice/fail \
             /home/runner/work/actions/actions/snapshot-master/libexec/bundle install --retry 0
           Resolving dependencies...
           Using bundler 2.1.4
           Bundle complete! 1 Gemfile dependency, 1 gem now installed.
           Use `bundle info [gemname]` to see where a bundled gem is installed.
           fatal: not a git repository (or any of the parent directories): .git
           fatal: not a git repository (or any of the parent directories): .git
           fatal: not a git repository (or any of the parent directories): .git
           # $? => 0

           $ /home/runner/work/actions/actions/snapshot-master/ruby \
             -I/home/runner/work/actions/actions/snapshot-master/lib:/home/runner/work/actions/actions/snapshot-master/spec/bundler \
             -rsupport/hax -rsupport/artifice/fail \
             /home/runner/work/actions/actions/snapshot-master/libexec/bundle exec ruby -e \
             require\ \'bundler\'\;\ Bundler.setup
           fatal: not a git repository (or any of the parent directories): .git
           fatal: not a git repository (or any of the parent directories): .git
           fatal: not a git repository (or any of the parent directories): .git
           # $? => 0
         # ./spec/bundler/runtime/setup_spec.rb:1056:in `block (3 levels) in <top (required)>'
         # ./spec/bundler/spec_helper.rb:111:in `block (3 levels) in <top (required)>'
         # ./spec/bundler/spec_helper.rb:111:in `block (2 levels) in <top (required)>'
         # ./spec/bundler/spec_helper.rb:78:in `block (2 levels) in <top (required)>'
    make: *** [yes-test-bundler] Error 1
    ```

    * [ruby/irb] Unnamed groups are not captured when named groups are used

    https://github.com/ruby/irb/commit/0a641a69b0

    * [ruby/reline] Work with wrong $/ value correctly

    https://github.com/ruby/reline/commit/962ebf5a1b

    * [ruby/irb] Detect multiple lines output simplify

    The old implementation performance test code:

        require 'objspace'
        puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)
        /\A.*\Z/ !~ ('abc' * 20_000_000)
        puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

    and run `time test.rb`:

        2.5868 MB
        62.226 MB

        real    0m1.307s
        user    0m0.452s
        sys     0m0.797s

    The new implementation performance test code:

        require 'objspace'
        puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)
        ('abc' * 20_000_000).include?("\n")
        puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

    and run `time test.rb`:

        2.5861 MB
        62.226 MB

        real    0m0.132s
        user    0m0.088s
        sys     0m0.042s

    https://github.com/ruby/irb/commit/40d6610baf

    * [ruby/reline] Suppress error in case INPUTRC env is empty

    https://github.com/ruby/reline/commit/bce7e7562b

    * [ruby/reline] Add yamatanooroti rendering test

    https://github.com/ruby/reline/commit/f092519525

    * [ruby/reline] Rename test suite name of yamatanooroti test

    https://github.com/ruby/reline/commit/b0f32f5de4

    * [ruby/reline] Add a comment why rescue yamatanooroti loading error on the test

    https://github.com/ruby/reline/commit/2a8061daec

    * [ruby/irb] Suppress crashing when EncodingError has occurred without lineno

    https://github.com/ruby/irb/commit/13572d8cdc

    * [ruby/reline] Suppress error when check ambiguous char width in LANG=C

    https://github.com/ruby/reline/commit/623dffdd75

    * [ruby/io-console] Enable only interrupt bits on `intr: true`

    https://github.com/ruby/io-console/commit/baaf929041

    * [ruby/io-console] bump up to 0.5.4

    * [ruby/io-console] Update the minimum requirement of Ruby version

    https://github.com/ruby/io-console/commit/73e7b6318a

    * [ruby/io-console] Filter Ruby engine name rather than just /ruby/

    This breaks tests using this path on JRuby because the `jruby`
    executable turns into `jjruby` after the sub.

    https://github.com/ruby/io-console/commit/e5951aa34c

    * [ruby/io-console] bump up to 0.5.5

    * [ruby/io-console] Prefer keyword arguments

    https://github.com/ruby/io-console/commit/5facbfc4c8

    * [ruby/io-console] [DOC] Improved about `intr:`

    https://github.com/ruby/io-console/commit/82b630cd79

    * [ruby/io-console] Just ignore the extension on other than CRuby

    https://github.com/ruby/io-console/commit/41b6f09574

    * [ruby/io-console] bump up to 0.5.6

    Co-authored-by: KOBAYASHI Shuji <shuujii@gmail.com>
    Co-authored-by: Ben <kanobt61@gmail.com>
    Co-authored-by: Yusuke Endoh <mame@ruby-lang.org>
    Co-authored-by: MSP-Greg <MSP-Greg@users.noreply.github.com>
    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
    Co-authored-by: Kenta Murata <mrkn@mrkn.jp>
    Co-authored-by: Lars Kanis <lars@greiz-reinsdorf.de>
    Co-authored-by: Lars Kanis <kanis@comcard.de>
    Co-authored-by: Alan Wu <XrXr@users.noreply.github.com>
    Co-authored-by: Hiroshi SHIBATA <hsbt@ruby-lang.org>
    Co-authored-by: Nobuhiro IMAI <nov@yo.rim.or.jp>
    Co-authored-by: Nick Lewis <nick@puppet.com>
    Co-authored-by: S-H-GAMELINKS <gamelinks007@gmail.com>
    Co-authored-by: Koichi Sasada <ko1@atdot.net>
    Co-authored-by: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
    Co-authored-by: Charles Oliver Nutter <headius@headius.com>

commit ecf874edea92796c63cc2b50b36b1179de5114c6
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2020-03-28 06:14:02 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2020-03-28 06:14:02 +0900

    * 2020-03-28 [ci skip]

commit 22c3014e36219b072fd6b1e963c4c64c7015a3cd
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2020-03-03 20:54:31 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-28 04:01:23 +0900

    Suppress an "assigned but unused variable" warning

    (cherry picked from commit 501f2c44e6ae79c02a5c4d0f872fc7fa77258fcf)

commit 44f7e3883e49d287a96f7ef36b5c935d833300e5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-03-03 15:48:53 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-28 04:01:15 +0900

    Preserve `kwarg` flag and fix up f5c904c2a9

    (cherry picked from commit c8d0bf0156878df03a71fffc97c44abf7333d5d7)

commit aeda3a7f036aa7c768abffd1965972c658f49c22
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2020-03-02 22:37:04 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-27 14:57:47 +0900

    Suppress "assigned but unused variable" warnings

    (cherry picked from commit 65dd50fc25f6522536d5c4749055384bde1f9371)

commit 004c298738dc0924e7483b0c3f41c798dabe9e5b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-03-02 15:49:03 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-27 14:57:42 +0900

    Allow newlines inside braced pattern

    (cherry picked from commit f5c904c2a907013e22ff74bc3686952c5448d493)

commit 93aaa0bcce829b880d8f52a9168d17c93ecde85b
  Author:     Kazuki Tsujimoto <kazuki@callcc.net>
  AuthorDate: 2020-03-01 14:23:51 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-27 14:57:36 +0900

    Allow trailing comma in hash pattern

    (cherry picked from commit d25a4f413dce6ad3a8baaf61591415b9a8cce082)

commit 5ccf57f23eb7a35ac699edc2fc598c47fa1844a0
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-03-25 22:00:15 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-27 14:51:35 +0900

    Make RbConfig::CONFIG values mutable [Bug #16738]

    As `RbConfig.expand` modifies the argument and involved `CONFIG`
    values, its values should be mutable.

    (cherry picked from commit 4adb2d655dcd54b28366b4d17e86b21e2b622cd1)

commit 7b5133801340cfa7e4e4e5dd61384cb90c3f6085
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2020-01-08 16:11:52 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-27 14:43:20 +0900

    Merge bundler-2.1.4

commit 572021c6e4e01c3b8ece90ad42fdd4ee71b8acc5
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2020-03-26 23:51:12 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2020-03-26 23:51:12 +0900

    * 2020-03-26 [ci skip]

commit c9a7643a7e5993975e7e8c985df157d73b16a490
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2020-03-21 15:46:33 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-26 22:17:08 +0900

    test/openssl/test_ssl.rb: ignore SSLError when the connection is closed

    "test_close_after_socket_close" checks if ssl.close is no-op even after
    the wrapped socket is closed.  The test itself is fair, but the other
    endpoint that is reading the SSL connection may fail with SSLError:
    "SSL_read: unexpected eof while reading" in some environments:

    https://github.com/ruby/ruby/actions/runs/60085389 (MinGW)
    https://rubyci.org/logs/rubyci.s3.amazonaws.com/android28-x86_64/ruby-master/log/20200321T034442Z.fail.html.gz
    ```
      1) Failure:
    OpenSSL::TestSSL#test_close_after_socket_close [D:/a/ruby/ruby/src/test/openssl/utils.rb:299]:
    exceptions on 1 threads:
    SSL_read: unexpected eof while reading
    ```

    This changeset rescues and ignores the SSLError in the test.

    (cherry picked from commit be76e86e69106c6906322dc30aa75c3ff65da63c)

commit 897d4e31b0e5b29405480ed3236bc8c5c6cac3fa
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2020-03-07 03:55:54 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-26 21:18:26 +0900

    check ar_table first.

    RHASH_AR_TABLE_SIZE() has assertion that it is a ar_talbe.
    The last commit breaks this assumption so check ar_table first.

    (cherry picked from commit c3584dfacce4d0f2058d8403de6fdce4fd4d686b)

commit ab6f78bc926f6fc12dc8d7846056fc9c04d63ead
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2020-03-07 03:32:15 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-26 21:18:26 +0900

    check ar_table after `#hash` call

    ar_table can be converted to st_table just after `ar_do_hash()`
    function which calls `#hash` method. We need to check
    the representation to detect this mutation.
    [Bug #16676]

    (cherry picked from commit 4c019f5a626523e99e2827ed917802e3097c380d)

commit e4efca87ba1aa5b6a94b9007040ac3e783c26b43
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2020-03-26 01:16:50 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-26 21:18:26 +0900

    check flags passed to rb_nogvl()

    RB_NOGVL_UBF_ASYNC_SAFE is wrongly specified because flags
    is not checked.
    [Bug #15499] 23444302

    (cherry picked from commit ff98931daca1265e5bd33025d160c77e452c399e)

commit 2a3027b7b54a3118731f70c9e88aabbd495bb9fe
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2020-03-14 09:59:55 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-26 21:18:25 +0900

    Add missing write barrier for Hash#transform_values{,!}

    21994b7fd686f263544fcac1616ecf3189fb78b3 removed the write barrier that
    was present in rb_hash_aset(). Re-insert it to not crash during GC.

    [Bug #16689]

    (cherry picked from commit 713dc619f5372a645b66bef9dacee217c4101cb4)

commit 95c3bb6c426a11253644a86137bb67c542fd5799
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-03-16 17:26:10 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-26 21:18:25 +0900

    Do not make disabled directories at installation  [Bug #12392]

    (cherry picked from commit 8a6ba10f9dd456cf54de800203cf04bbe42271fb)

commit 1853efc46dba862c50df7710cfbacded999ae2ec
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2020-03-26 21:17:07 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-26 21:18:25 +0900

    Use power_assert 1.1.7

    Mainly for pry compatibility in test
    https://github.com/k-tsj/power_assert/commit/dcc14cbef48d9790187fa400a5df7531d81a5971

    Also include "Show full_message if available"
    https://github.com/k-tsj/power_assert/commit/53ce0400bf47f722830d6604be0a2e30cccabf34

commit 47b08728cf3d0441a3da4dc1dcdd578817b0e036
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2020-03-12 21:55:20 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-15 20:53:14 +0900

    [ruby/stringio] StringIO#initialize default to the source string encoding

    [Bug #16497]

    https://github.com/ruby/stringio/commit/4958a5ccab
    (cherry picked from commit e257c08f2ec27e2d66cdfa7e2415deb492522e22)

commit 3efbd527a86203406664a01126784a10eb136405
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2020-01-25 05:13:41 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-15 20:52:43 +0900

    Do not autosplat when calling proc with empty keyword splat

    With the removal of the splatted argument when using an empty
    keyword splat, the autosplat code considered an empty keyword
    splat the same as no argument at all.  However, that results
    in autosplat behavior changing dependent on the content of
    the splatted hash, which is not what anyone would expect or
    want.  This change always skips an autosplat if keywords were
    provided.

    Fixes [Bug #16560]

    (cherry picked from commit c1d8829ef515ee51fadeadd7dd022b5c47a71cdd)

commit c858a10ce87033beec63516fe6407b50c6539177
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2020-03-15 19:35:48 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2020-03-15 19:35:48 +0900

    * 2020-03-15 [ci skip]

commit a36ead3f4fe801ddaebe6d1ed905e9e3276dbac7
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2020-02-29 16:58:33 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-15 19:35:24 +0900

    Prevent unloading methods used in root_fiber while calling another Fiber (#2939)

    Fixing SEGVs like:
    http://ci.rvm.jp/results/trunk-mjit-wait@silicon-docker/2744905
    http://ci.rvm.jp/results/trunk-mjit-wait@silicon-docker/2744420
    http://ci.rvm.jp/results/trunk-mjit-wait@silicon-docker/2741400
    [Bug #16664]

    (cherry picked from commit adcf0316d1ecedae2a9157ad941550e0c0fb510b)

commit 17e925b9917f4877f2da8c64316feb3ce1ca2932
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2020-02-29 16:20:44 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-15 19:35:24 +0900

    Avoid infinite loop on --jit-wait

    (cherry picked from commit a8dcab723316997d9e01c89d6df969edce75bdca)

commit c6944377d798e088042f2944b81aa3fa8a4e5411
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2020-02-03 20:29:37 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-15 19:35:24 +0900

    Fix SimpleDelegator respond_to? regression

    In 2.6, SimpleDelegator would always use the target `respond_to?`

    In 2.7.0 it doesn't if the target does not inherit from Object.

    This breaks compatibility for delegated objects that inherit
    from BasicObject and redefine `respond_to?`. [Bug #16606]

    (cherry picked from commit f2552216d43040cd42bbb9fd484eab6c70856fe6)

commit d07a6dc10efa71123b36a4a3ff7d2ec6e52804d7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-01-21 11:47:04 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-15 19:35:24 +0900

    delegate.rb: fixed keyword arguments in DelegateClass

    `Delegator.delegating_block` should delegate keyword arguments
    separately.  [ruby-core:96949]

    (cherry picked from commit 9bcf4f3db26249772c983896ebbc9ff41f4614db)

commit e70d52b0c377f8b2ed04311710c0ca9f4ebabd90
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2020-02-25 06:19:37 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-15 19:35:24 +0900

    Make ruby2_keywords methods correctly handle **{} optimization

    Previously, this code:

      ruby2_keywords def foo(*a) a.last end
      foo(**{})

    Returned an empty frozen hash.  However, the final hash should
    not be frozen in this case, as it wouldn't be if foo accepted
    a keyword splat.

    Use a new unfrozen empty hash instead of reusing the frozen empty
    hash in this case.

    Fixes [Bug #16642]

commit b3fabedc7043593812c9ad507b4648a55d74df99
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2020-03-14 20:27:57 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2020-03-14 20:27:57 +0900

    * 2020-03-14 [ci skip]

commit e7555d467b882fa8213f17643b00557ed420b640
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2019-12-31 16:20:17 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-14 16:32:29 +0900

    Drop MinGW build from AppVeyor

    in favor of #2791

    (cherry picked from commit b00418732c89ce42c1c4cef57d08344659fbdd2b)

commit 0d24fb774d84d4a99454ce10fd343da00049a588
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2020-03-09 23:57:16 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-14 16:15:15 +0900

    Don't display singleton class in Method#inspect unless method defined there

    Previously, if an object has a singleton class, and you call
    Object#method on the object, the resulting string would include
    the object's singleton class, even though the method was not
    defined in the singleton class.

    Change this so the we only show the singleton class if the method
    is defined in the singleton class.

    Fixes [Bug #15608]

    (cherry picked from commit e02bd0e713ef920e6d12c27f16548f48ec5c2cf0)

commit eabf35a5d298c68f45dc600477fc586d7b868788
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-02-10 12:15:48 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-14 16:12:44 +0900

    Fixed duplicated warning

    As `command_rhs` is always a "value expression", `command_asgn`
    does not need the same check. [Bug #16619]

    (cherry picked from commit 6e6844320de989cb88a154e2ac75066ccea1bba2)

commit fa48a26d886d86469a0075d91d152252e9fc0c8c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-02-24 15:33:50 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-14 16:00:46 +0900

    Fixed symbol misused as ID

    `rb_funcallv_public` and `rb_respond_to` require an `ID`, not a
    `Symbol`.  [Bug #16649]

    (cherry picked from commit 8b6e2685a4b7c7de905f7ed60c02ef85e0724754)

commit 3e7e1b965b06f3c843972d7e2f6e3d040374d67f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-02-18 14:34:26 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-13 23:27:19 +0900

    Pass keyword arguments to IOs properly [Bug #16639]

    (cherry picked from commit 041c2932e336b509b0ddc1fdbd9f160bce8d4893)

commit 2339be74e737b4c5f5330f845af2e7db0c7450e1
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2020-02-15 16:27:03 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-13 22:38:05 +0900

    lib/drb/drb.rb: Use ruby2_keywords for keyword separation

    [Bug #16634]

    (cherry picked from commit fb472ca7adbaceb35aae1b3a6b948720ffc9eb53)

commit c7e0ce67430b5e312eb626a2c2f4b6a810b3b68b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-02-04 15:21:49 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-13 22:34:09 +0900

    Add the loaded feature after no exception raised

    Retrying after rescued `require` should try to load the same
    library again.  [Bug #16607]

    (cherry picked from commit 7d6903dc476f982e7b432adbeef3a3d9372a309f)

commit 7518b4e945675df9aca223c30ca711e1d82341ec
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2020-03-13 22:31:29 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-13 22:31:29 +0900

    fix the order of definition

commit fcaa00e58fd3a4cbaa19c6558783b43ee324d19e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2020-03-07 20:42:44 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-13 22:23:12 +0900

    Use osuosl instead of GitHub releases

      Because the package provided by GitHub releases is different from sourceware.

    (cherry picked from commit 47a1872cd8b901b8aab6dedce7fa3807c97d290d)

commit 6a2d779027818eda418c9118f700b36816e833a5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2020-03-07 19:57:28 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-13 22:23:02 +0900

    Switch to download libffi source package to github releases from sourceware.org

    [Bug #16681]
    (cherry picked from commit 86022167461dc90b70164e2bb23316959bbfd6ba)

commit 60d98fad86da1ada204c53789431ac0f5f3390ff
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-01-17 23:49:26 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-13 22:10:07 +0900

    [ruby/io-console] Set `OPOST` when `intr` is true

    To enable implementation-defined output processing, for the
    compatibility with readline.  [Bug #16509]

    https://bugs.ruby-lang.org/issues/16509

    https://github.com/ruby/io-console/commit/8c8b0b6757
    (cherry picked from commit 4e56ec4ef74cf77dbcb4ce7c669e0595cd0d12fa)

commit 9f504bb474770f1cac68988eac2a410e41c4bbb8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-02-09 16:56:40 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-13 22:08:42 +0900

    Separate objspace argument for rb_gc_disable and rb_gc_enable

    (cherry picked from commit aeaf0dc55595b8a5bfdd92007fb85ef13855c632)

commit 047dfbdf69e1a300109c729c66b6a761032402dd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-01-28 09:18:12 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-13 21:53:09 +0900

    Skip empty directories to install [Bug #16596]

    (cherry picked from commit 33d02e6bc7502c5a3f09c59908a8c9f08a474b8d)

commit 5bdbee96e479f714c7f9b6b98f012268cbd9051b
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2020-03-13 21:43:44 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-13 21:51:06 +0900

    Squashed commit of the following: [Backport #16516]

    commit c98c492578d898dc07a04b8240d8d5b1508ffafa
    Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
    Date:   Fri Jan 17 16:56:53 2020 +0900

        Added test for f38b3e8c707ebdcad05aa9485cf1760640b74fbb

    commit f38b3e8c707ebdcad05aa9485cf1760640b74fbb
    Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
    Date:   Thu Jan 16 18:34:31 2020 +0900

        Fixed the location of args node with numbered parameter

commit a9284ecb90176b4d8e9aa264da14ea08931be48f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-02-09 16:41:56 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-13 21:51:06 +0900

    Disable GC until VM objects get initialized [Bug #16616]

commit 215eb86a7729bf0db487f399031ad55a1062fada
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2020-01-15 22:40:01 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-13 21:51:06 +0900

    Increase the frozen_strings table initial size

    It was set to 1000 in a4a2b9be7a55bb61d17cf9673ed0d2a93bb52d31.

    However on ruby-2.7.0p0, there are much more than 1k frozen string right after boot:

    ```
    $ ruby -robjspace -e 'p ObjectSpace.each_object(String).select { |s| s.frozen? && ObjectSpace.dump(s).include?(%{"fstring":true})}.uniq.count'
    5948
    ```

commit 8a54630a6608d9b1a9d32db2ba33289a5454810d
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2020-03-13 21:32:13 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2020-03-13 21:32:13 +0900

    * 2020-03-13 [ci skip]

commit 3c93ed59773ca547239850d16f06451afbb0aeec
  Author:     Adam Isom <adam.r.isom@gmail.com>
  AuthorDate: 2020-01-17 06:42:36 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-03-13 21:31:10 +0900

    Update documentation for Array/Hash Argument section of methods.rdoc

    [Bug #16514]

commit c3cd92582f970812be51310e377c82b6d9e7be92
  Author:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  AuthorDate: 2020-02-20 00:13:44 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-02-20 17:08:45 +0900

    Use `brew upgrade` instead of `brew update`

commit 0149863dff42e0b7b6876cc3669aa3efcab6776e
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2020-02-20 16:36:30 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2020-02-20 16:36:30 +0900

    * 2020-02-20 [ci skip]

commit eaee631d5eda03f77ec39ec6fc1826a06ab06205
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2020-02-19 16:16:19 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-02-20 16:36:10 +0900

    Avoid jumping to a wrong destination

    when the next insn is already compiled by former branches.

commit ccc3b9119c39a6cb08a643ab3d15a9c07ec28b1a
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2020-02-18 15:30:37 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2020-02-18 15:30:37 +0900

    * 2020-02-18 [ci skip]

commit 789c1df10a13a53d0504d4ba87c4e246692b1973
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2020-02-18 15:30:00 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-02-18 15:30:00 +0900

    increment teeny

commit 0643eb2e59dbd80f9be001c2ec77c980e8aeff3f
  Author:     Ryuta Kamizono <kamipo@gmail.com>
  AuthorDate: 2020-01-19 12:49:40 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-02-18 15:09:46 +0900

    Fix typo s/test_ruby2_keywords_hash!/test_ruby2_keywords_hash/

    In #2818, `Hash.ruby2_keywords!` has renamed to `Hash.ruby2_keywords_hash`.

commit 9820f9ee0aaccd78e6e0489e8915d3925c6ee97c
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2020-01-06 18:22:43 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-02-18 15:09:46 +0900

    hash.c: Add a feature to manipulate ruby2_keywords flag

    It was found that a feature to check and add ruby2_keywords flag to an
    existing Hash is needed when arguments are serialized and deserialized.
    It is possible to do the same without explicit APIs, but it would be
    good to provide them as a core feature.

    https://github.com/rails/rails/pull/38105#discussion_r361863767

    Hash.ruby2_keywords_hash?(hash) checks if hash is flagged or not.
    Hash.ruby2_keywords_hash(hash) returns a duplicated hash that has a
    ruby2_keywords flag,

    [Bug #16486]

commit 420a88d3da6deb5f7d4d8e088cb3737b9a23d29d
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2020-02-13 15:23:02 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2020-02-13 15:23:02 +0900

    * 2020-02-13 [ci skip]

commit 78cbe7106b67d007ffdcc1276b352212eaaef4b2
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-01-31 12:52:22 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-02-13 14:07:14 +0900

    Return the makefile content

    Block for `create_makefile` is expected to return the content of
    the makefile.

commit b8e62ccaecf49372833d7eeeb3fdfded4bb2f042
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2020-01-31 08:00:56 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-02-13 14:07:07 +0900

    Move .IGNORE in extconf.rb

commit a89821243da3c80e08bf46669e16ae46d687c80b
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2020-01-31 06:34:49 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-02-13 14:06:59 +0900

    Support nmake

commit a930174d798b58ee10493bf192d277ffe08518a7
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2020-01-31 02:46:05 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-02-13 14:06:53 +0900

    Ignore expected errors on compiling C++ source [Bug #16331]

    BSD make can run parallel more aggressively than GNU make. It communicate
    with other make process through -J option in MAKEFLAGS environment variable
    to notify a build failure happend in an other pararell make process.
    https://www.freebsd.org/cgi/man.cgi?make

    It usually works well but ext/-test-/cxxanyargs/Makefile has two targets
    which are expected to fail (failure.o and failurem1.o).

    Additional note:
    To test and debug this issue, following command will speed up it.
    `make -f exts.mk -j8 clean all`

commit 95ab9cd8f453099d7649dc0e0eec55ea891340f5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-02-11 15:52:25 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-02-13 13:50:57 +0900

    Restart timer thread even after preparation failed

    If the timer thread is left stopped, memory crash or segfault can
    happen. [Bug #16624]

commit 9c07f803db1c20241fa73e91a8a959d6cbb82e8b
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2020-01-30 13:36:47 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:36:47 +0900

    check ruby_2_7 branch

commit 49430aa4e5bf4020dbdb1cce3bc547cffad6ffae
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-01-19 11:02:18 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:35:18 +0900

    Allow rexml to fail on macOS of Github Actions

    And revert "Stop test-bundled-gems on macOS for now",
    28b290f7f4cb332dab3ddf3132e1916d413ea65c.

commit 30a9dc4aa9cb1985cfe5bd318b8b35dacc103127
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-01-19 09:48:33 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:35:18 +0900

    Stop test-bundled-gems on macOS for now

commit 095a937dc2c0924dbfda7f7625ac2921a10de231
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2020-01-17 17:25:05 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:35:18 +0900

    .github/workflows/cygwin.yml: Removed

    There is no active maintainer for cygwin.  The CI failure is too noisy.

    [Misc #16407]

commit 5eced3c030f39d10e193c5e33a70365d8e011bb1
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-01-13 10:02:04 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:35:17 +0900

    Checkout with git on cygwin for EOL code

    `shell: bash` runs bash on msys which prefers git on msys too,
    then checked out in CRLF mode.  Cygwin sed doesn't consider the CR
    a part of EOL code, though.

commit 6ec6acd76ed7c718a469841afe4f32571e757c9d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2020-01-12 09:59:10 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:35:17 +0900

    Allow failures with rss tests on test-bundled-gems

commit 504b082f364e35516b2727c11713c28b684b5af0
  Author:     Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  AuthorDate: 2020-01-11 16:24:16 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:35:17 +0900

    Add branch option to checkout on push

commit 5dc82455aef4a42817208e11fbfbcdc1351f0734
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2020-01-06 18:52:19 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:35:17 +0900

    Slightly change the job wording [ci skip]

    mame-san said it's weird

commit 7d4243254629004007a390f7f1afc4a570a1fd00
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2020-01-06 18:45:47 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:35:17 +0900

    Support running Actions on a fork

    Since 8c9450e7b875db846b19cc631af0d7fee66db5c6, we increased the chance
    to run GitHub Actions on a fork, as we usually use a topic branch
    instead of master when filing a pull request.

    This patch makes it possible to reuse the same GitHub Actions config on
    a fork repository.

commit bd48a28b1cb9848d194a82139d018f87dd689f99
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2020-01-06 18:42:30 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:35:17 +0900

    Directly refer to GitHub events

    instead of unnecessarily defining env vars

commit 48f82ad28961c0998b1d426493614875bb487d29
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2020-01-01 15:03:07 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:35:16 +0900

    Remove code to prevent double build on trunk

    trunk branch was deleted.

commit fdd9d7cd41cde130889d84414395da22706972c8
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2020-01-01 14:26:39 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:34:25 +0900

    More consistent failure notifications

    The format is the same as Travis / AppVeyor now.

commit 531bbec111d588ad497dd528eae3ac36e2af2632
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2020-01-01 08:27:40 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:34:25 +0900

    Make test run condition consistent with other jobs

    When `make all` fails, we should not run tests and output of such run is
    confusing.

commit 4d04b32986bb73bfd5d5e56bcd17cfa82c90885c
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2020-01-01 03:24:00 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:34:25 +0900

    Run tests in the consistent order

    `make check` runs test -> test-all -> test-spec, and other CIs follow that too.

commit 24621f23e5cc9403910b82e671c2b299ec65bd67
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2020-01-01 02:37:03 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:34:25 +0900

    Fix an outdated comment

    We're actually using it for PR :p

commit e3dfd9f2b5729d4d8ac4541110af409ee218aadd
  Author:     MSP-Greg <MSP-Greg@users.noreply.github.com>
  AuthorDate: 2020-01-01 02:35:43 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:34:25 +0900

    Actions MinGW - fix test-all (#2803)

commit a24d2f3b8cf98d067f6648a0609b6251d3e0a464
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2020-01-01 02:34:29 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:34:25 +0900

    Use actions/checkout for PR (#2804)

commit 77dfa520d476143b8be6c4805354838012b4d335
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2019-12-31 18:49:08 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:34:25 +0900

    Official actions/checkout is useless

    It died again https://github.com/ruby/ruby/runs/368837347

commit 124878c6aad7c708d7121199bea29962713d319a
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2019-12-31 16:46:17 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:34:24 +0900

    Make Slack notifications consistent

commit 110b4e974ddb74472a0eb3ce181705b47eb28d50
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2019-12-31 16:42:20 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:34:24 +0900

    There's no such target

commit 4d9f106eaefeee4b160d3c5580039c64ff9c01ae
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2019-12-31 16:30:34 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:34:24 +0900

    Make all Actions job names consistent

    like "{platform} / make ({make target}, ...)"

commit ca48fa8e81ca19f4d0c24017662245c933be86eb
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2019-12-31 16:23:25 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:34:24 +0900

    Do not doubly build on trunk

commit 44ef8af4fb0a793f020147e3f077cd061953c8fa
  Author:     MSP-Greg <MSP-Greg@users.noreply.github.com>
  AuthorDate: 2019-12-31 16:19:31 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:34:24 +0900

    MinGW on Actions (#2791)

    * MinGW - skip spec in spec/ruby/optional/capi/thread_spec.rb

    C-API Thread function rb_thread_call_without_gvl
          -- runs a C function with the global lock unlocked and unlocks IO with the generic RUBY_UBF_IO

    stops/freezes spec tests

    See https://bugs.ruby-lang.org/issues/16265

    * MinGW - skip test test/resolv/test_dns.rb

    Test times out in CI (both AppVeyor & Actions), cannot repo locally

    * MinGW - skip test test/ruby/test_thread_queue.rb

    * Add Actions mingw.yml

commit 6646c2b2ab7efd389075ad5f187b458c4bc138cc
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2019-12-31 16:09:24 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 13:34:24 +0900

    Revert "Remove TEST_BUNDLED_GEMS_ALLOW_FAILURES"

    This reverts commit 75e8dd58f69c190c9698d0133942032903fb2f07.

    We seem to randomly hit another issue these days:
    https://github.com/ruby/ruby/runs/368756135
    https://github.com/ruby/ruby/runs/368756191

commit 716e05b82338d75452e86c999ae3e5874a642ecd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-01-27 10:46:57 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-30 10:01:46 +0900

    Fixed a segfault `GC.verify_compaction_references`

    Which is by coercion of `Qundef`, when any keyword argument
    without `toward:` option is given.  [Bug #16598]

commit 52bb32d6b71365cb24273de3eed5a712206815f3
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2019-12-31 08:13:55 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-16 17:52:04 +0900

    Fix Proc#<< spec

    [Bug #16406]

commit db4d136889afbf59e69efcfd495fd91cd401f378
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2020-01-16 11:25:43 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-16 15:26:28 +0900

    `Regexp` in `MatchData` can be `nil`

    `String#sub` with a string pattern defers creating a `Regexp`
    until `MatchData#regexp` creates a `Regexp` from the matched
    string.  `Regexp#last_match(group_name)` accessed its content
    without creating the `Regexp` though.  [Bug #16508]

commit 8e8841f6bf58031a1fe5b0dbacb5a1fb442102df
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2020-01-13 03:36:47 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-16 15:13:08 +0900

    reload AR table body for transient heap.

    ar_talbe (Hash representation for <=8 size) can use transient heap
    and the memory area can move. So we need to restore `pair' ptr after
    `func` call (which can run any programs) because of moving.
    [Bug #16503]

commit 48f324e92f9b36edc267f9871e35039cbd1c2eb9
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2020-01-09 08:21:42 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-16 15:09:42 +0900

    lib/net/imap.rb: use `&blk` instead of Kernel#proc with no block

    [Bug #16488]

commit 580edc25aa00930bdb71b244d70a2007905f5fec
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2020-01-06 11:36:51 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2020-01-16 15:08:36 +0900

    script_compiled event on compile error.

    script_compiled event for TracePoint should not be invoked on
    compile error (SyntaxError) because it is not "compiled".
    [Bug #16459]

commit 647ee6f091eafcce70ffb75ddf7e121e192ab217
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-25 18:46:39 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2019-12-25 18:50:58 +0900

    [ruby/reline] Version 0.1.2

    https://github.com/ruby/reline/commit/b41024e317

commit 1341a279a4becd91f35b23eca6d129990eccc8bb
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-25 18:45:02 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2019-12-25 18:50:58 +0900

    Save last breaking point to complete

commit a52e364e6541a6e234718ac63aa7eb5c3f2c832f
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2019-12-25 18:02:53 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2019-12-25 18:50:58 +0900

    fix version regexp

commit ecbf7fe27ce444782f0a48fc41f8043a25078666
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2019-12-25 17:01:26 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2019-12-25 18:50:57 +0900

    fix typo

commit a65e8644fb97491314387e4138cabf6378a8e8d5
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2019-12-25 15:48:56 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2019-12-25 15:48:56 +0900

    v2.7.0p0

commit 75dca097b873222eaf3c70b7f43e3ffb98b7f2ed
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2019-12-25 14:13:15 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2019-12-25 15:38:55 +0900

    [bundler/bundler] Do `require "rubygems"` only when needed

    This require causes circular require.

    ```
    $ touch empty_file

    $ RUBYGEMS_GEMDEPS=empty_file ./local/bin/ruby -w -e ''
    /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92: warning: /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92: warning: loading in progress, circular require considered harmful - /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems.rb
            from <internal:gem_prelude>:1:in  `<internal:gem_prelude>'
            from <internal:gem_prelude>:1:in  `require'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems.rb:1417:in  `<top (required)>'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems.rb:1203:in  `use_gemdeps'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/user_interaction.rb:47:in  `use_ui'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems.rb:1204:in  `block in use_gemdeps'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92:in  `require'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92:in  `require'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/bundler.rb:11:in  `<top (required)>'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/bundler.rb:11:in  `require_relative'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/bundler/rubygems_integration.rb:3:in  `<top (required)>'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92:in  `require'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92:in  `require'
    ```

    https://github.com/bundler/bundler/commit/c7c5bcea92

commit 27453b04c85249372950b6b12fabbef8c0d1a80b
  Author:     Kenta Murata <mrkn@users.noreply.github.com>
  AuthorDate: 2019-12-25 15:21:50 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2019-12-25 15:21:50 +0900

    Update the version of bigdecimal to 2.0.0 (#2784)

  Notes:
    Merged-By: mrkn <mrkn@ruby-lang.org>

commit 56e002981fab73a94c6038cb9de82aba6ff84eb4
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2019-12-25 14:47:31 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2019-12-25 14:49:48 +0900

    Show the error line only when same as the current

commit 9808e010907bb16068497d9f0f8593a7165fa42d
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2019-12-25 14:37:53 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2019-12-25 14:37:53 +0900

    export a function for MJIT.

    rb_iseq_complete() can be used by MJIT.

commit d9bf9c572f461c282fa6e65833e98bc7d453a66f
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2019-12-25 14:10:35 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2019-12-25 14:12:33 +0900

    take care of USE_LAZY_LOAD=1.

    On USE_LAZY_LOAD=1, the iseq should be loaded. So rb_iseq_check()
    is needed. Furthermore, now lazy loading with builtin_function_table
    is not supported, so it should cancel lazy loading.

commit 81e377023c490998a3fec245ca2fb2b3c710c2c6
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2019-12-25 13:35:22 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2019-12-25 13:36:23 +0900

    range.c: Range#min with a beginless one now raises an explicit exception

    [Bug #16450]

commit cd6c013b075c9c27437f30efcee9d4dd9e0ee1c5
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-25 12:55:31 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-25 12:55:53 +0900

    Add readline and readline-ext to default gems list in NEWS

commit 227c3d642631262acfbf140c566a7841c32b372f
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2019-12-25 12:06:02 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2019-12-25 12:06:16 +0900

    add ref to NEWS entry

commit 3345eab934073bdd8394ee8a46fc18954999af76
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2019-12-25 11:37:27 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2019-12-25 11:37:27 +0900

    NEWS: add a ticket reference

commit b9e35d27096290f9544dca685fb4cf5bd0e09397
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2019-12-25 11:31:44 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2019-12-25 11:31:44 +0900

    NEWS: add a ticket reference

commit e0929c44ddc7490dc97cabf12c7505173316a623
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2019-12-25 11:27:13 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2019-12-25 11:27:13 +0900

    NEWS: add ticket references

commit eb3f19b9b896094ae9754de1b48fed86fb35fe39
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2019-12-25 11:17:24 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2019-12-25 11:20:07 +0900

    update-bundled_gems: drop branch name on github [ci skip]

commit 00710d10761ad1aa752cf2c035e3bfbde40092b6
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-25 10:47:53 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-25 10:57:44 +0900

    [ruby/readline] Version 0.0.2

    https://github.com/ruby/readline/commit/42b71f3fc0

commit e51a34511c9e4394467cde24deee19cf8536a3e7
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-25 10:47:34 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-25 10:57:38 +0900

    [ruby/readline] Use a box to make easier to see the message

    https://github.com/ruby/readline/commit/e49e942053

commit 57c74841c7bc2bb2ffbb8ed89597e993116e26a8
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-25 10:44:52 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-25 10:57:29 +0900

    [ruby/readline] Fix any wrong in messages

    https://github.com/ruby/readline/commit/a2cf437c8f

commit de0f4f2fd7620e2486f5aef031dad18324437c2b
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-25 10:30:24 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-25 10:56:11 +0900

    [ruby/readline] Version 0.0.1

    https://github.com/ruby/readline/commit/d2363cad33

commit 5d20865708552a522d5eb39c4d9238f96693f8f2
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-25 10:25:15 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-25 10:55:51 +0900

    [ruby/readline] Add post_install_message

    https://github.com/ruby/readline/commit/03126372b5

commit 999a2819a75e40aec405e088d01b12eda341025d
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-25 10:31:03 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-25 10:53:44 +0900

    [ruby/readline-ext] Version 0.1.0

    https://github.com/ruby/readline-ext/commit/f5abaf5be1

commit 246242700867ed3fdce8288897d74bd261379018
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-25 10:08:06 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-25 10:08:39 +0900

    [ruby/reline] Version 0.1.1

    https://github.com/ruby/reline/commit/923f97d068

commit ed5b4bae6a4f991a0c5299581bd0b137a98d3723
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-25 09:52:25 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-25 09:52:37 +0900

    The behavior of vi_end_of_transmission should be the same of vi_list_or_eof

commit 03c504ac59a2bf78bab925379e93184d81296e96
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2019-12-25 09:38:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2019-12-25 09:38:12 +0900

    Commented-out btest on cygwin environment of GitHub Actions

commit 622e47a1dbeee52fb218b816943b69cb88e17ae6
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-25 09:29:46 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-25 09:34:13 +0900

    ^D on non-empty line in vi mode behaves like Enter

commit 8e6d51e09a93ae2c57d56105a5fd39fb92855394
  Author:     Yuki Nishijima <yk.nishijima@gmail.com>
  AuthorDate: 2019-12-25 08:41:26 +0900
  Commit:     Yuki Nishijima <yk.nishijima@gmail.com>
  CommitDate: 2019-12-25 08:41:55 +0900

    Sync did_you_mean

commit 2b2be71cabf987effd2783747eedf573af1400cf
  Author:     Yuki Nishijima <yk.nishijima@gmail.com>
  AuthorDate: 2019-12-25 08:23:59 +0900
  Commit:     Yuki Nishijima <yk.nishijima@gmail.com>
  CommitDate: 2019-12-25 08:24:55 +0900

    Add did_you_mean's promotion to the NEWS

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2782

commit 1857b4427817755bb0879ca67e1b2f3276f95d4c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2019-12-25 07:28:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2019-12-25 07:28:02 +0900

    Merge Bundler 2.1.2 from bundler/bundler.

    [Misc #16449][ruby-core:96458]

commit da0a0bae8b50087d140309b27eb4d4b4776c27e4
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-25 06:13:49 +0900
  Commit:     Marcus Stollsteimer <sto.mar@web.de>
  CommitDate: 2019-12-25 06:13:49 +0900

    NEWS: add meaning of "CoW" ("copy-on-write")

commit ceba5b70889666b82b80910a441cf4a92b5c7160
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-25 05:50:27 +0900
  Commit:     Marcus Stollsteimer <sto.mar@web.de>
  CommitDate: 2019-12-25 05:50:27 +0900

    [DOC] Fix typo in Time#inspect

commit f3067deb88badf8d15e49d13f082284f58b2c62b
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2019-12-25 04:54:20 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2019-12-25 04:54:20 +0900

    Revert "Add NEWS entry about Module#name performance (#2779)" (#2781)

    This reverts commit 3e9221d94a12b54c1285923b642364acdbc31c7e.

  Notes:
    Merged-By: XrXr

commit 3e9221d94a12b54c1285923b642364acdbc31c7e
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2019-12-25 04:02:50 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2019-12-25 04:02:50 +0900

    Add NEWS entry about Module#name performance (#2779)

  Notes:
    Merged-By: XrXr

commit 5220145ea289d9eb955b373f31773fab2d4f0271
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2019-12-25 01:32:37 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2019-12-25 01:34:41 +0900

    add debug_counter access functions.

    These functions are enabled only on USE_DEBUG_COUNTER=1.

commit 9b617ffa8884f9f80a0b1bdb89169d8139ba5001
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2019-12-25 01:00:40 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2019-12-25 01:00:40 +0900

    * 2019-12-25 [ci skip]

commit 3679023df822d8bf3f88b9b2e4b849318d2c409e
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-25 00:57:30 +0900
  Commit:     Marcus Stollsteimer <sto.mar@web.de>
  CommitDate: 2019-12-25 00:57:30 +0900

    [DOC] Fix typo and language

commit 8c017824c8eeffe11070ce69c914725af314d9f6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2019-12-24 22:31:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2019-12-24 22:31:38 +0900

    Added entry for json-2.3.0

commit 1cd2ebed616473ed56730292879e8bc9d6dfd060
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2019-12-24 21:39:37 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2019-12-24 21:39:37 +0900

    Update the news entries for RubyGems and Bundler

commit 05b0410f91360e15511903580f0401b123f3abce
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-24 21:17:00 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-24 21:22:46 +0900

    [ruby/irb] Fix typo

    https://github.com/ruby/irb/commit/4bb1340687

commit 54083fd41bf876b42e1a97acdc7574c8edbb87ed
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-24 21:01:47 +0900
  Commit:     Marcus Stollsteimer <sto.mar@web.de>
  CommitDate: 2019-12-24 21:01:47 +0900

    [DOC] Fix grammar in Process module docs

commit 66e518f7b3e0bf307f86a51e6db02c3d1ec8df84
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-24 21:01:24 +0900
  Commit:     Marcus Stollsteimer <sto.mar@web.de>
  CommitDate: 2019-12-24 21:01:24 +0900

    [DOC] Fix typo

commit 4ba9347554ab1ac79fdaf1d5b3320776a2b10615
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2019-12-24 18:49:57 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2019-12-24 18:53:14 +0900

    `Object#=~` warning also obeys `Warning[:deprecated]`

commit a3c5dbf29191aa8622d8be7d990c4ac2f9392427
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2019-12-24 14:56:17 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2019-12-24 18:53:14 +0900

    Scale sleeping times to wait for the OS operations

commit 7758849cb5432ae974f616668f9c9bab415bb18a
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-24 18:39:48 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-24 18:39:48 +0900

    Remove unused variable

commit 42e2a322f100c7c798fcfbcbbfe0b4cdaf3f5855
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-24 18:32:50 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-24 18:34:43 +0900

    The delete-char-or-list shows completed list when called at end of line

    It doesn't behave the same as the delete-char.

commit b03aea62abfbdc7c8ee53c30a27127c3c394a6ba
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-24 18:02:22 +0900
  Commit:     Marcus Stollsteimer <sto.mar@web.de>
  CommitDate: 2019-12-24 18:02:22 +0900

    NEWS: fix method references for Range#{cover?,include?}

commit 44a1f51695058159ff2f191c97a082bed9665137
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-24 17:49:22 +0900
  Commit:     Marcus Stollsteimer <sto.mar@web.de>
  CommitDate: 2019-12-24 17:49:22 +0900

    NEWS: improve sections for warning option / Warning

commit 27b4f477d960c75f3ff5cd5e045b307cad314ec7
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-24 17:03:42 +0900
  Commit:     Marcus Stollsteimer <sto.mar@web.de>
  CommitDate: 2019-12-24 17:03:42 +0900

    [DOC] Improve docs for Enumerator.produce, Enumerator.new

commit 81504e83e72bf125476528e5f119604d9697f682
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2019-12-24 15:47:59 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2019-12-24 15:48:08 +0900

    Synchronize with a Queue instead of sleeping

commit 47ad57f2450251f47b3f8e1f744d782269bbcdeb
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2019-12-24 15:38:46 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2019-12-24 15:38:46 +0900

    Revert "Scale sleeping times"

    This reverts commit e57d6194218efc73c30f3fed9dd321d2e357030b.

    Test fails:
    http://ci.rvm.jp/results/trunk-gc-asserts@ruby-sky1/2518563
    http://ci.rvm.jp/results/trunk-gc_compact@silicon-docker/2518533

commit c47106699cf2bcf426285efcd795223c200a3120
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2019-12-24 14:57:55 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2019-12-24 14:57:55 +0900

    NEWS: added references to warning option [ci skip]

commit e57d6194218efc73c30f3fed9dd321d2e357030b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2019-12-24 14:56:17 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2019-12-24 14:56:17 +0900

    Scale sleeping times

commit adf498b84f56e57b74b72a3ddcc512f6d2078cef
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2019-12-24 13:24:41 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2019-12-24 13:24:41 +0900

    Moved warning option section and added a reference [ci skip]

commit 302e896833bc611ba39c8697712313fd2dbd70cc
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2019-12-24 13:12:28 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2019-12-24 13:12:28 +0900

    Added warning.rb to .document

commit 3739ddc36f462b794ec05c0cfc36458a8d1e17a7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2019-12-24 12:11:42 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2019-12-24 12:11:42 +0900

    Added `-W:experimental` to `--help` [Feature #16420]

commit d0f1eb3e4ef7cde2d78b493b3ba1561eee79b18f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2019-12-24 11:28:18 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2019-12-24 11:28:18 +0900

    Separated command line option in NEWS [ci skip]

commit 5a62fb1277fb351a1a11b89b0f8510c8f1a0cdff
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2019-12-24 11:14:13 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2019-12-24 11:14:16 +0900

    Mentioned `-W:` command option in NEWS [ci skip]

commit f2e1e6cba451375d8eb839bf2e7c9a39bccc044c
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2019-12-22 06:23:20 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2019-12-24 11:00:39 +0900

    Enhance explanations for beginless range and #clamp, and add missing feature

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2769

commit e954be14d07e54b8dbf71c0fa227e5818eaa01e6
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2019-12-24 10:27:18 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2019-12-24 10:33:32 +0900

    Get rid of false positive misspellings

    [Bug #16437]

commit 992aa2cda50140abbca165024682eae998756e2d
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2019-12-24 10:24:45 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2019-12-24 10:33:32 +0900

    enc/x_emoji.h: fixed dead-links [ci skip]

    English version pages seem no longer provided.

commit f09a4ff265093742c356c69bcf56db68bd6cf064
  Author:     manga_osyo <manga.osyo@gmail.com>
  AuthorDate: 2019-12-24 09:53:36 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2019-12-24 10:30:43 +0900

    Added NEWS for Feature 15373

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2777

commit 360f153fcaab637486aa2669d354d53e0eb1c3d2
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2019-12-24 10:23:38 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2019-12-24 10:25:21 +0900

    remove "experimental" from numbered parameter.

    Numbered parameter is not an experimental feature,
    confirmed by Matz.
    https://twitter.com/yukihiro_matz/status/1209271452798607361

commit 5e17834fc900a699241764ef0baacd53992d7f07
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-24 09:55:05 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-24 09:56:40 +0900

    [ruby/reline] Version 0.1.0

    https://github.com/ruby/reline/commit/55d4dfec1e

commit 8316b330fb04413bb480462941cb6b14c5352e2e
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-24 09:54:38 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-24 09:56:40 +0900

    [ruby/irb] Version 1.2.1

    https://github.com/ruby/irb/commit/8da0c74640

commit 0e528ae9cb5c1078e4d07287e403cb548e97f0a3
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-24 09:53:43 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-24 09:56:40 +0900

    [ruby/irb] Remove warning message to bundle on Ruby 2.7.0

    https://github.com/ruby/irb/commit/d9a7844f50

commit 0231661939310951c8ed339d8600a53a21015918
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-24 08:13:46 +0900
  Commit:     Marcus Stollsteimer <sto.mar@web.de>
  CommitDate: 2019-12-24 08:13:46 +0900

    [DOC] Fix wording in Math::E documentation

commit 30c5e8c4b9353dfb716033901cec7529eace3922
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-24 08:03:00 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-24 08:04:01 +0900

    [ruby/rdoc] Version 6.2.1

    https://github.com/ruby/rdoc/commit/c65e14d112

commit 2bf0743edcf6fd70cd73952e1e023821c4549a9e
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-24 07:58:49 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-24 07:58:53 +0900

    Update parsers of RDoc that are generated by Racc

commit adc9b3ca7f4e75e368731fe8a7092ce078bcec04
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-24 07:41:37 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-24 07:58:53 +0900

    [ruby/rdoc] Support newline in the middle of constant definition

    https://github.com/ruby/rdoc/commit/74d3984324

commit e50e55269358520dc55595a9c3e074d351d96b66
  Author:     aycabta <aycabta@gmail.com>
  AuthorDate: 2019-12-24 07:00:35 +0900
  Commit:     aycabta <aycabta@gmail.com>
  CommitDate: 2019-12-24 07:58:53 +0900

    [ruby/rdoc] Treat Proc#call syntax sugar for constant correctly

    https://github.com/ruby/rdoc/commit/957d041ae0

commit 819b604037c317d2b53a1aaca67aef25da2d5ec9
  Author:     Marc-Andre Lafortune <github@marc-andre.ca>
  AuthorDate: 2019-12-23 16:34:16 +0900
  Commit:     Marc-Andre Lafortune <github@marc-andre.ca>
  CommitDate: 2019-12-24 06:47:33 +0900

    Reword keyword arguments warning messages to convey these are deprecation warnings

commit df6f5c44af1f261fa940ec3954468be8b820450e
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-24 06:41:58 +0900
  Commit:     Marcus Stollsteimer <sto.mar@web.de>
  CommitDate: 2019-12-24 06:41:58 +0900

    [DOC] Fix invalid code to make it syntax highlighted

commit a7b5018495c4a6b82d779958b086647226ce61e7
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-24 06:07:02 +0900
  Commit:     Marcus Stollsteimer <sto.mar@web.de>
  CommitDate: 2019-12-24 06:07:02 +0900

    [DOC] Use capitalized "Ruby"

commit ba9ccef81811e9387c0189d596189236b25d0dba
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-24 06:04:59 +0900
  Commit:     Marcus Stollsteimer <sto.mar@web.de>
  CommitDate: 2019-12-24 06:04:59 +0900

    [DOC] Various fixes in bug triaging guide

commit aa01441fd29be8be28644db7abac9f7940fcc814
  Author:     git <svn-admin@ruby-lang.org>
  AuthorDate: 2019-12-24 04:17:11 +0900
  Commit:     git <svn-admin@ruby-lang.org>
  CommitDate: 2019-12-24 04:17:11 +0900

    * 2019-12-24 [ci skip]

commit f201700051cc107b55c425bf331ce6d7ad3ef22b
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2019-12-24 04:16:40 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2019-12-24 04:16:40 +0900

    move a NEWS entry about inline method cache

commit 16fddfe352828d26aaa6cdbce696e62de04511ce
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-23 23:02:59 +0900
  Commit:     Marcus Stollsteimer <sto.mar@web.de>
  CommitDate: 2019-12-23 23:02:59 +0900

    [DOC] Improve readability of requirements for <=>

commit 9a42e0c7ed4dcc57043a8a35a50686625adba686
  Author:     Marcus Stollsteimer <sto.mar@web.de>
  AuthorDate: 2019-12-23 22:46:58 +0900
  Commit:     Marcus Stollsteimer <sto.mar@web.de>
  CommitDate: 2019-12-23 22:46:58 +0900

    NEWS: add reference for [Feature #14405]

commit de1a462454f4196490263c9be8be16a44513f5a0
  Author:     Marcus Stollsteimer <sto.mar@web.de>
